//// Automatically generated by generate-swiftsyntax
//// Do not edit directly!
//===----------------------------------------------------------------------===//
//
// This source file is part of the Swift.org open source project
//
// Copyright (c) 2014 - 2023 Apple Inc. and the Swift project authors
// Licensed under Apache License v2.0 with Runtime Library Exception
//
// See https://swift.org/LICENSE.txt for license information
// See https://swift.org/CONTRIBUTORS.txt for the list of Swift project authors
//
//===----------------------------------------------------------------------===//

//
// This file defines the SyntaxRewriter, a class that performs a standard walk
// and tree-rebuilding pattern.
//
// Subclassers of this class can override the walking behavior for any syntax
// node and transform nodes however they like.
//
//===----------------------------------------------------------------------===//

open class SyntaxRewriter {
  public let viewMode: SyntaxTreeViewMode
  
  public init(viewMode: SyntaxTreeViewMode = .sourceAccurate) {
    self.viewMode = viewMode
  }
  
  /// Rewrite `node`, keeping its parent unless `detach` is `true`.
  public func rewrite(_ node: some SyntaxProtocol, detach: Bool = false) -> Syntax {
    let rewritten = self.visit(node.data)
    if detach {
      return rewritten
    }

    return withExtendedLifetime(rewritten) {
      return Syntax(node.data.replacingSelf(rewritten.raw, rawNodeArena: rewritten.raw.arena, allocationArena: SyntaxArena()))
    }
  }
  
  /// Visit a ``TokenSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ token: TokenSyntax) -> TokenSyntax {
    return token
  }
  
  /// The function called before visiting the node and its descendants.
  ///   - node: the node we are about to visit.
  open func visitPre(_ node: Syntax) {
  }
  
  /// Override point to choose custom visitation dispatch instead of the
  /// specialized `visit(_:)` methods. Use this instead of those methods if
  /// you intend to dynamically dispatch rewriting behavior.
  /// - note: If this method returns a non-nil result, the specialized
  ///         `visit(_:)` methods will not be called for this node and the
  ///         visited node will be replaced by the returned node in the
  ///         rewritten tree.
  open func visitAny(_ node: Syntax) -> Syntax? {
    return nil
  }
  
  /// The function called after visiting the node and its descendants.
  ///   - node: the node we just finished visiting.
  open func visitPost(_ node: Syntax) {
  }
  
  /// Visit any Syntax node.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  @available(*, deprecated, renamed: "rewrite(_:detach:)")
  public func visit(_ node: Syntax) -> Syntax {
    return visit(node.data)
  }
  
  public func visit<T: SyntaxChildChoices>(_ node: T) -> T {
    return visit(node.data).cast(T.self)
  }
  
  /// Visit a ``AccessorBlockSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AccessorBlockSyntax) -> AccessorBlockSyntax {
    return Syntax(visitChildren(node)).cast(AccessorBlockSyntax.self)
  }
  
  /// Visit a ``AccessorDeclListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AccessorDeclListSyntax) -> AccessorDeclListSyntax {
    return Syntax(visitChildren(node)).cast(AccessorDeclListSyntax.self)
  }
  
  /// Visit a ``AccessorDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AccessorDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``AccessorEffectSpecifiersSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AccessorEffectSpecifiersSyntax) -> AccessorEffectSpecifiersSyntax {
    return Syntax(visitChildren(node)).cast(AccessorEffectSpecifiersSyntax.self)
  }
  
  /// Visit a ``AccessorParametersSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AccessorParametersSyntax) -> AccessorParametersSyntax {
    return Syntax(visitChildren(node)).cast(AccessorParametersSyntax.self)
  }
  
  /// Visit a ``ActorDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ActorDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``ArrayElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ArrayElementListSyntax) -> ArrayElementListSyntax {
    return Syntax(visitChildren(node)).cast(ArrayElementListSyntax.self)
  }
  
  /// Visit a ``ArrayElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ArrayElementSyntax) -> ArrayElementSyntax {
    return Syntax(visitChildren(node)).cast(ArrayElementSyntax.self)
  }
  
  /// Visit a ``ArrayExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ArrayExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ArrayTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ArrayTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``ArrowExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ArrowExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``AsExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AsExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``AssignmentExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AssignmentExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``AssociatedTypeDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AssociatedTypeDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``AttributeListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AttributeListSyntax) -> AttributeListSyntax {
    return Syntax(visitChildren(node)).cast(AttributeListSyntax.self)
  }
  
  /// Visit a ``AttributeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AttributeSyntax) -> AttributeSyntax {
    return Syntax(visitChildren(node)).cast(AttributeSyntax.self)
  }
  
  /// Visit a ``AttributedTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AttributedTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``AvailabilityArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AvailabilityArgumentListSyntax) -> AvailabilityArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(AvailabilityArgumentListSyntax.self)
  }
  
  /// Visit a ``AvailabilityArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AvailabilityArgumentSyntax) -> AvailabilityArgumentSyntax {
    return Syntax(visitChildren(node)).cast(AvailabilityArgumentSyntax.self)
  }
  
  /// Visit a ``AvailabilityConditionSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AvailabilityConditionSyntax) -> AvailabilityConditionSyntax {
    return Syntax(visitChildren(node)).cast(AvailabilityConditionSyntax.self)
  }
  
  /// Visit a ``AvailabilityLabeledArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AvailabilityLabeledArgumentSyntax) -> AvailabilityLabeledArgumentSyntax {
    return Syntax(visitChildren(node)).cast(AvailabilityLabeledArgumentSyntax.self)
  }
  
  /// Visit a ``AwaitExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: AwaitExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``BackDeployedAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: BackDeployedAttributeArgumentsSyntax) -> BackDeployedAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(BackDeployedAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``BinaryOperatorExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: BinaryOperatorExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``BooleanLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: BooleanLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``BorrowExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: BorrowExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``BreakStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: BreakStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``CanImportExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CanImportExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``CanImportVersionInfoSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CanImportVersionInfoSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``CatchClauseListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CatchClauseListSyntax) -> CatchClauseListSyntax {
    return Syntax(visitChildren(node)).cast(CatchClauseListSyntax.self)
  }
  
  /// Visit a ``CatchClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CatchClauseSyntax) -> CatchClauseSyntax {
    return Syntax(visitChildren(node)).cast(CatchClauseSyntax.self)
  }
  
  /// Visit a ``CatchItemListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CatchItemListSyntax) -> CatchItemListSyntax {
    return Syntax(visitChildren(node)).cast(CatchItemListSyntax.self)
  }
  
  /// Visit a ``CatchItemSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CatchItemSyntax) -> CatchItemSyntax {
    return Syntax(visitChildren(node)).cast(CatchItemSyntax.self)
  }
  
  /// Visit a ``ClassDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClassDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``ClassRestrictionTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClassRestrictionTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``ClosureCaptureClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureCaptureClauseSyntax) -> ClosureCaptureClauseSyntax {
    return Syntax(visitChildren(node)).cast(ClosureCaptureClauseSyntax.self)
  }
  
  /// Visit a ``ClosureCaptureListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureCaptureListSyntax) -> ClosureCaptureListSyntax {
    return Syntax(visitChildren(node)).cast(ClosureCaptureListSyntax.self)
  }
  
  /// Visit a ``ClosureCaptureSpecifierSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureCaptureSpecifierSyntax) -> ClosureCaptureSpecifierSyntax {
    return Syntax(visitChildren(node)).cast(ClosureCaptureSpecifierSyntax.self)
  }
  
  /// Visit a ``ClosureCaptureSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureCaptureSyntax) -> ClosureCaptureSyntax {
    return Syntax(visitChildren(node)).cast(ClosureCaptureSyntax.self)
  }
  
  /// Visit a ``ClosureExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ClosureParameterClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureParameterClauseSyntax) -> ClosureParameterClauseSyntax {
    return Syntax(visitChildren(node)).cast(ClosureParameterClauseSyntax.self)
  }
  
  /// Visit a ``ClosureParameterListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureParameterListSyntax) -> ClosureParameterListSyntax {
    return Syntax(visitChildren(node)).cast(ClosureParameterListSyntax.self)
  }
  
  /// Visit a ``ClosureParameterSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureParameterSyntax) -> ClosureParameterSyntax {
    return Syntax(visitChildren(node)).cast(ClosureParameterSyntax.self)
  }
  
  /// Visit a ``ClosureShorthandParameterListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureShorthandParameterListSyntax) -> ClosureShorthandParameterListSyntax {
    return Syntax(visitChildren(node)).cast(ClosureShorthandParameterListSyntax.self)
  }
  
  /// Visit a ``ClosureShorthandParameterSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureShorthandParameterSyntax) -> ClosureShorthandParameterSyntax {
    return Syntax(visitChildren(node)).cast(ClosureShorthandParameterSyntax.self)
  }
  
  /// Visit a ``ClosureSignatureSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ClosureSignatureSyntax) -> ClosureSignatureSyntax {
    return Syntax(visitChildren(node)).cast(ClosureSignatureSyntax.self)
  }
  
  /// Visit a ``CodeBlockItemListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CodeBlockItemListSyntax) -> CodeBlockItemListSyntax {
    return Syntax(visitChildren(node)).cast(CodeBlockItemListSyntax.self)
  }
  
  /// Visit a ``CodeBlockItemSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CodeBlockItemSyntax) -> CodeBlockItemSyntax {
    return Syntax(visitChildren(node)).cast(CodeBlockItemSyntax.self)
  }
  
  /// Visit a ``CodeBlockSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CodeBlockSyntax) -> CodeBlockSyntax {
    return Syntax(visitChildren(node)).cast(CodeBlockSyntax.self)
  }
  
  /// Visit a ``CompositionTypeElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CompositionTypeElementListSyntax) -> CompositionTypeElementListSyntax {
    return Syntax(visitChildren(node)).cast(CompositionTypeElementListSyntax.self)
  }
  
  /// Visit a ``CompositionTypeElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CompositionTypeElementSyntax) -> CompositionTypeElementSyntax {
    return Syntax(visitChildren(node)).cast(CompositionTypeElementSyntax.self)
  }
  
  /// Visit a ``CompositionTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CompositionTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``ConditionElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ConditionElementListSyntax) -> ConditionElementListSyntax {
    return Syntax(visitChildren(node)).cast(ConditionElementListSyntax.self)
  }
  
  /// Visit a ``ConditionElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ConditionElementSyntax) -> ConditionElementSyntax {
    return Syntax(visitChildren(node)).cast(ConditionElementSyntax.self)
  }
  
  /// Visit a ``ConformanceRequirementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ConformanceRequirementSyntax) -> ConformanceRequirementSyntax {
    return Syntax(visitChildren(node)).cast(ConformanceRequirementSyntax.self)
  }
  
  /// Visit a ``ConsumeExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ConsumeExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ContinueStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ContinueStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``ConventionAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ConventionAttributeArgumentsSyntax) -> ConventionAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(ConventionAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``ConventionWitnessMethodAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ConventionWitnessMethodAttributeArgumentsSyntax) -> ConventionWitnessMethodAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(ConventionWitnessMethodAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``CopyExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: CopyExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``DeclModifierDetailSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclModifierDetailSyntax) -> DeclModifierDetailSyntax {
    return Syntax(visitChildren(node)).cast(DeclModifierDetailSyntax.self)
  }
  
  /// Visit a ``DeclModifierListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclModifierListSyntax) -> DeclModifierListSyntax {
    return Syntax(visitChildren(node)).cast(DeclModifierListSyntax.self)
  }
  
  /// Visit a ``DeclModifierSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclModifierSyntax) -> DeclModifierSyntax {
    return Syntax(visitChildren(node)).cast(DeclModifierSyntax.self)
  }
  
  /// Visit a ``DeclNameArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclNameArgumentListSyntax) -> DeclNameArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(DeclNameArgumentListSyntax.self)
  }
  
  /// Visit a ``DeclNameArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclNameArgumentSyntax) -> DeclNameArgumentSyntax {
    return Syntax(visitChildren(node)).cast(DeclNameArgumentSyntax.self)
  }
  
  /// Visit a ``DeclNameArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclNameArgumentsSyntax) -> DeclNameArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(DeclNameArgumentsSyntax.self)
  }
  
  /// Visit a ``DeclReferenceExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeclReferenceExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``DeferStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeferStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``DeinitializerDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeinitializerDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``DeinitializerEffectSpecifiersSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DeinitializerEffectSpecifiersSyntax) -> DeinitializerEffectSpecifiersSyntax {
    return Syntax(visitChildren(node)).cast(DeinitializerEffectSpecifiersSyntax.self)
  }
  
  /// Visit a ``DerivativeAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DerivativeAttributeArgumentsSyntax) -> DerivativeAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(DerivativeAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``DesignatedTypeListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DesignatedTypeListSyntax) -> DesignatedTypeListSyntax {
    return Syntax(visitChildren(node)).cast(DesignatedTypeListSyntax.self)
  }
  
  /// Visit a ``DesignatedTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DesignatedTypeSyntax) -> DesignatedTypeSyntax {
    return Syntax(visitChildren(node)).cast(DesignatedTypeSyntax.self)
  }
  
  /// Visit a ``DictionaryElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DictionaryElementListSyntax) -> DictionaryElementListSyntax {
    return Syntax(visitChildren(node)).cast(DictionaryElementListSyntax.self)
  }
  
  /// Visit a ``DictionaryElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DictionaryElementSyntax) -> DictionaryElementSyntax {
    return Syntax(visitChildren(node)).cast(DictionaryElementSyntax.self)
  }
  
  /// Visit a ``DictionaryExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DictionaryExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``DictionaryTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DictionaryTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``DifferentiabilityArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DifferentiabilityArgumentListSyntax) -> DifferentiabilityArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(DifferentiabilityArgumentListSyntax.self)
  }
  
  /// Visit a ``DifferentiabilityArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DifferentiabilityArgumentSyntax) -> DifferentiabilityArgumentSyntax {
    return Syntax(visitChildren(node)).cast(DifferentiabilityArgumentSyntax.self)
  }
  
  /// Visit a ``DifferentiabilityArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DifferentiabilityArgumentsSyntax) -> DifferentiabilityArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(DifferentiabilityArgumentsSyntax.self)
  }
  
  /// Visit a ``DifferentiabilityWithRespectToArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DifferentiabilityWithRespectToArgumentSyntax) -> DifferentiabilityWithRespectToArgumentSyntax {
    return Syntax(visitChildren(node)).cast(DifferentiabilityWithRespectToArgumentSyntax.self)
  }
  
  /// Visit a ``DifferentiableAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DifferentiableAttributeArgumentsSyntax) -> DifferentiableAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(DifferentiableAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``DiscardAssignmentExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DiscardAssignmentExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``DiscardStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DiscardStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``DoStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DoStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``DocumentationAttributeArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DocumentationAttributeArgumentListSyntax) -> DocumentationAttributeArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(DocumentationAttributeArgumentListSyntax.self)
  }
  
  /// Visit a ``DocumentationAttributeArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DocumentationAttributeArgumentSyntax) -> DocumentationAttributeArgumentSyntax {
    return Syntax(visitChildren(node)).cast(DocumentationAttributeArgumentSyntax.self)
  }
  
  /// Visit a ``DynamicReplacementAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: DynamicReplacementAttributeArgumentsSyntax) -> DynamicReplacementAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(DynamicReplacementAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``EditorPlaceholderDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EditorPlaceholderDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``EditorPlaceholderExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EditorPlaceholderExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``EffectsAttributeArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EffectsAttributeArgumentListSyntax) -> EffectsAttributeArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(EffectsAttributeArgumentListSyntax.self)
  }
  
  /// Visit a ``EnumCaseDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumCaseDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``EnumCaseElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumCaseElementListSyntax) -> EnumCaseElementListSyntax {
    return Syntax(visitChildren(node)).cast(EnumCaseElementListSyntax.self)
  }
  
  /// Visit a ``EnumCaseElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumCaseElementSyntax) -> EnumCaseElementSyntax {
    return Syntax(visitChildren(node)).cast(EnumCaseElementSyntax.self)
  }
  
  /// Visit a ``EnumCaseParameterClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumCaseParameterClauseSyntax) -> EnumCaseParameterClauseSyntax {
    return Syntax(visitChildren(node)).cast(EnumCaseParameterClauseSyntax.self)
  }
  
  /// Visit a ``EnumCaseParameterListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumCaseParameterListSyntax) -> EnumCaseParameterListSyntax {
    return Syntax(visitChildren(node)).cast(EnumCaseParameterListSyntax.self)
  }
  
  /// Visit a ``EnumCaseParameterSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumCaseParameterSyntax) -> EnumCaseParameterSyntax {
    return Syntax(visitChildren(node)).cast(EnumCaseParameterSyntax.self)
  }
  
  /// Visit a ``EnumDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: EnumDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``ExposeAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ExposeAttributeArgumentsSyntax) -> ExposeAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(ExposeAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``ExprListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ExprListSyntax) -> ExprListSyntax {
    return Syntax(visitChildren(node)).cast(ExprListSyntax.self)
  }
  
  /// Visit a ``ExpressionPatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ExpressionPatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``ExpressionSegmentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ExpressionSegmentSyntax) -> ExpressionSegmentSyntax {
    return Syntax(visitChildren(node)).cast(ExpressionSegmentSyntax.self)
  }
  
  /// Visit a ``ExpressionStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ExpressionStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``ExtensionDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ExtensionDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``FallThroughStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FallThroughStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``FloatLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FloatLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ForStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ForStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``ForceUnwrapExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ForceUnwrapExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``FunctionCallExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionCallExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``FunctionDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``FunctionEffectSpecifiersSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionEffectSpecifiersSyntax) -> FunctionEffectSpecifiersSyntax {
    return Syntax(visitChildren(node)).cast(FunctionEffectSpecifiersSyntax.self)
  }
  
  /// Visit a ``FunctionParameterClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionParameterClauseSyntax) -> FunctionParameterClauseSyntax {
    return Syntax(visitChildren(node)).cast(FunctionParameterClauseSyntax.self)
  }
  
  /// Visit a ``FunctionParameterListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionParameterListSyntax) -> FunctionParameterListSyntax {
    return Syntax(visitChildren(node)).cast(FunctionParameterListSyntax.self)
  }
  
  /// Visit a ``FunctionParameterSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionParameterSyntax) -> FunctionParameterSyntax {
    return Syntax(visitChildren(node)).cast(FunctionParameterSyntax.self)
  }
  
  /// Visit a ``FunctionSignatureSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionSignatureSyntax) -> FunctionSignatureSyntax {
    return Syntax(visitChildren(node)).cast(FunctionSignatureSyntax.self)
  }
  
  /// Visit a ``FunctionTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: FunctionTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``GenericArgumentClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericArgumentClauseSyntax) -> GenericArgumentClauseSyntax {
    return Syntax(visitChildren(node)).cast(GenericArgumentClauseSyntax.self)
  }
  
  /// Visit a ``GenericArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericArgumentListSyntax) -> GenericArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(GenericArgumentListSyntax.self)
  }
  
  /// Visit a ``GenericArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericArgumentSyntax) -> GenericArgumentSyntax {
    return Syntax(visitChildren(node)).cast(GenericArgumentSyntax.self)
  }
  
  /// Visit a ``GenericParameterClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericParameterClauseSyntax) -> GenericParameterClauseSyntax {
    return Syntax(visitChildren(node)).cast(GenericParameterClauseSyntax.self)
  }
  
  /// Visit a ``GenericParameterListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericParameterListSyntax) -> GenericParameterListSyntax {
    return Syntax(visitChildren(node)).cast(GenericParameterListSyntax.self)
  }
  
  /// Visit a ``GenericParameterSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericParameterSyntax) -> GenericParameterSyntax {
    return Syntax(visitChildren(node)).cast(GenericParameterSyntax.self)
  }
  
  /// Visit a ``GenericRequirementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericRequirementListSyntax) -> GenericRequirementListSyntax {
    return Syntax(visitChildren(node)).cast(GenericRequirementListSyntax.self)
  }
  
  /// Visit a ``GenericRequirementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericRequirementSyntax) -> GenericRequirementSyntax {
    return Syntax(visitChildren(node)).cast(GenericRequirementSyntax.self)
  }
  
  /// Visit a ``GenericSpecializationExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericSpecializationExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``GenericWhereClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GenericWhereClauseSyntax) -> GenericWhereClauseSyntax {
    return Syntax(visitChildren(node)).cast(GenericWhereClauseSyntax.self)
  }
  
  /// Visit a ``GuardStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: GuardStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``IdentifierPatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IdentifierPatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``IdentifierTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IdentifierTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``IfConfigClauseListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IfConfigClauseListSyntax) -> IfConfigClauseListSyntax {
    return Syntax(visitChildren(node)).cast(IfConfigClauseListSyntax.self)
  }
  
  /// Visit a ``IfConfigClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IfConfigClauseSyntax) -> IfConfigClauseSyntax {
    return Syntax(visitChildren(node)).cast(IfConfigClauseSyntax.self)
  }
  
  /// Visit a ``IfConfigDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IfConfigDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``IfExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IfExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ImplementsAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ImplementsAttributeArgumentsSyntax) -> ImplementsAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(ImplementsAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``ImplicitlyUnwrappedOptionalTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ImplicitlyUnwrappedOptionalTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``ImportDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ImportDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``ImportPathComponentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ImportPathComponentListSyntax) -> ImportPathComponentListSyntax {
    return Syntax(visitChildren(node)).cast(ImportPathComponentListSyntax.self)
  }
  
  /// Visit a ``ImportPathComponentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ImportPathComponentSyntax) -> ImportPathComponentSyntax {
    return Syntax(visitChildren(node)).cast(ImportPathComponentSyntax.self)
  }
  
  /// Visit a ``InOutExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InOutExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``InfixOperatorExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InfixOperatorExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``InheritanceClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InheritanceClauseSyntax) -> InheritanceClauseSyntax {
    return Syntax(visitChildren(node)).cast(InheritanceClauseSyntax.self)
  }
  
  /// Visit a ``InheritedTypeListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InheritedTypeListSyntax) -> InheritedTypeListSyntax {
    return Syntax(visitChildren(node)).cast(InheritedTypeListSyntax.self)
  }
  
  /// Visit a ``InheritedTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InheritedTypeSyntax) -> InheritedTypeSyntax {
    return Syntax(visitChildren(node)).cast(InheritedTypeSyntax.self)
  }
  
  /// Visit a ``InitializerClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InitializerClauseSyntax) -> InitializerClauseSyntax {
    return Syntax(visitChildren(node)).cast(InitializerClauseSyntax.self)
  }
  
  /// Visit a ``InitializerDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: InitializerDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``IntegerLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IntegerLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``IsExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IsExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``IsTypePatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: IsTypePatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``KeyPathComponentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: KeyPathComponentListSyntax) -> KeyPathComponentListSyntax {
    return Syntax(visitChildren(node)).cast(KeyPathComponentListSyntax.self)
  }
  
  /// Visit a ``KeyPathComponentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: KeyPathComponentSyntax) -> KeyPathComponentSyntax {
    return Syntax(visitChildren(node)).cast(KeyPathComponentSyntax.self)
  }
  
  /// Visit a ``KeyPathExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: KeyPathExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``KeyPathOptionalComponentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: KeyPathOptionalComponentSyntax) -> KeyPathOptionalComponentSyntax {
    return Syntax(visitChildren(node)).cast(KeyPathOptionalComponentSyntax.self)
  }
  
  /// Visit a ``KeyPathPropertyComponentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: KeyPathPropertyComponentSyntax) -> KeyPathPropertyComponentSyntax {
    return Syntax(visitChildren(node)).cast(KeyPathPropertyComponentSyntax.self)
  }
  
  /// Visit a ``KeyPathSubscriptComponentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: KeyPathSubscriptComponentSyntax) -> KeyPathSubscriptComponentSyntax {
    return Syntax(visitChildren(node)).cast(KeyPathSubscriptComponentSyntax.self)
  }
  
  /// Visit a ``LabeledExprListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: LabeledExprListSyntax) -> LabeledExprListSyntax {
    return Syntax(visitChildren(node)).cast(LabeledExprListSyntax.self)
  }
  
  /// Visit a ``LabeledExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: LabeledExprSyntax) -> LabeledExprSyntax {
    return Syntax(visitChildren(node)).cast(LabeledExprSyntax.self)
  }
  
  /// Visit a ``LabeledSpecializeArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: LabeledSpecializeArgumentSyntax) -> LabeledSpecializeArgumentSyntax {
    return Syntax(visitChildren(node)).cast(LabeledSpecializeArgumentSyntax.self)
  }
  
  /// Visit a ``LabeledStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: LabeledStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``LayoutRequirementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: LayoutRequirementSyntax) -> LayoutRequirementSyntax {
    return Syntax(visitChildren(node)).cast(LayoutRequirementSyntax.self)
  }
  
  /// Visit a ``MacroDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MacroDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``MacroExpansionDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MacroExpansionDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``MacroExpansionExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MacroExpansionExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``MatchingPatternConditionSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MatchingPatternConditionSyntax) -> MatchingPatternConditionSyntax {
    return Syntax(visitChildren(node)).cast(MatchingPatternConditionSyntax.self)
  }
  
  /// Visit a ``MemberAccessExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MemberAccessExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``MemberBlockItemListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MemberBlockItemListSyntax) -> MemberBlockItemListSyntax {
    return Syntax(visitChildren(node)).cast(MemberBlockItemListSyntax.self)
  }
  
  /// Visit a ``MemberBlockItemSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MemberBlockItemSyntax) -> MemberBlockItemSyntax {
    return Syntax(visitChildren(node)).cast(MemberBlockItemSyntax.self)
  }
  
  /// Visit a ``MemberBlockSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MemberBlockSyntax) -> MemberBlockSyntax {
    return Syntax(visitChildren(node)).cast(MemberBlockSyntax.self)
  }
  
  /// Visit a ``MemberTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MemberTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``MetatypeTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MetatypeTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``MissingDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MissingDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``MissingExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MissingExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``MissingPatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MissingPatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``MissingStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MissingStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``MissingSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MissingSyntax) -> Syntax {
    return Syntax(visitChildren(node))
  }
  
  /// Visit a ``MissingTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MissingTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``MultipleTrailingClosureElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MultipleTrailingClosureElementListSyntax) -> MultipleTrailingClosureElementListSyntax {
    return Syntax(visitChildren(node)).cast(MultipleTrailingClosureElementListSyntax.self)
  }
  
  /// Visit a ``MultipleTrailingClosureElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: MultipleTrailingClosureElementSyntax) -> MultipleTrailingClosureElementSyntax {
    return Syntax(visitChildren(node)).cast(MultipleTrailingClosureElementSyntax.self)
  }
  
  /// Visit a ``NamedOpaqueReturnTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: NamedOpaqueReturnTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``NilLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: NilLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ObjCSelectorPieceListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ObjCSelectorPieceListSyntax) -> ObjCSelectorPieceListSyntax {
    return Syntax(visitChildren(node)).cast(ObjCSelectorPieceListSyntax.self)
  }
  
  /// Visit a ``ObjCSelectorPieceSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ObjCSelectorPieceSyntax) -> ObjCSelectorPieceSyntax {
    return Syntax(visitChildren(node)).cast(ObjCSelectorPieceSyntax.self)
  }
  
  /// Visit a ``OpaqueReturnTypeOfAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OpaqueReturnTypeOfAttributeArgumentsSyntax) -> OpaqueReturnTypeOfAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(OpaqueReturnTypeOfAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``OperatorDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OperatorDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``OperatorPrecedenceAndTypesSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OperatorPrecedenceAndTypesSyntax) -> OperatorPrecedenceAndTypesSyntax {
    return Syntax(visitChildren(node)).cast(OperatorPrecedenceAndTypesSyntax.self)
  }
  
  /// Visit a ``OptionalBindingConditionSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OptionalBindingConditionSyntax) -> OptionalBindingConditionSyntax {
    return Syntax(visitChildren(node)).cast(OptionalBindingConditionSyntax.self)
  }
  
  /// Visit a ``OptionalChainingExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OptionalChainingExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``OptionalTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OptionalTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``OriginallyDefinedInAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: OriginallyDefinedInAttributeArgumentsSyntax) -> OriginallyDefinedInAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(OriginallyDefinedInAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``PackElementExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PackElementExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``PackElementTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PackElementTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``PackExpansionExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PackExpansionExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``PackExpansionTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PackExpansionTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``PatternBindingListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PatternBindingListSyntax) -> PatternBindingListSyntax {
    return Syntax(visitChildren(node)).cast(PatternBindingListSyntax.self)
  }
  
  /// Visit a ``PatternBindingSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PatternBindingSyntax) -> PatternBindingSyntax {
    return Syntax(visitChildren(node)).cast(PatternBindingSyntax.self)
  }
  
  /// Visit a ``PatternExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PatternExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``PlatformVersionItemListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PlatformVersionItemListSyntax) -> PlatformVersionItemListSyntax {
    return Syntax(visitChildren(node)).cast(PlatformVersionItemListSyntax.self)
  }
  
  /// Visit a ``PlatformVersionItemSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PlatformVersionItemSyntax) -> PlatformVersionItemSyntax {
    return Syntax(visitChildren(node)).cast(PlatformVersionItemSyntax.self)
  }
  
  /// Visit a ``PlatformVersionSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PlatformVersionSyntax) -> PlatformVersionSyntax {
    return Syntax(visitChildren(node)).cast(PlatformVersionSyntax.self)
  }
  
  /// Visit a ``PostfixIfConfigExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PostfixIfConfigExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``PostfixOperatorExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PostfixOperatorExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``PoundSourceLocationArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PoundSourceLocationArgumentsSyntax) -> PoundSourceLocationArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(PoundSourceLocationArgumentsSyntax.self)
  }
  
  /// Visit a ``PoundSourceLocationSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PoundSourceLocationSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``PrecedenceGroupAssignmentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupAssignmentSyntax) -> PrecedenceGroupAssignmentSyntax {
    return Syntax(visitChildren(node)).cast(PrecedenceGroupAssignmentSyntax.self)
  }
  
  /// Visit a ``PrecedenceGroupAssociativitySyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupAssociativitySyntax) -> PrecedenceGroupAssociativitySyntax {
    return Syntax(visitChildren(node)).cast(PrecedenceGroupAssociativitySyntax.self)
  }
  
  /// Visit a ``PrecedenceGroupAttributeListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupAttributeListSyntax) -> PrecedenceGroupAttributeListSyntax {
    return Syntax(visitChildren(node)).cast(PrecedenceGroupAttributeListSyntax.self)
  }
  
  /// Visit a ``PrecedenceGroupDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``PrecedenceGroupNameListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupNameListSyntax) -> PrecedenceGroupNameListSyntax {
    return Syntax(visitChildren(node)).cast(PrecedenceGroupNameListSyntax.self)
  }
  
  /// Visit a ``PrecedenceGroupNameSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupNameSyntax) -> PrecedenceGroupNameSyntax {
    return Syntax(visitChildren(node)).cast(PrecedenceGroupNameSyntax.self)
  }
  
  /// Visit a ``PrecedenceGroupRelationSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrecedenceGroupRelationSyntax) -> PrecedenceGroupRelationSyntax {
    return Syntax(visitChildren(node)).cast(PrecedenceGroupRelationSyntax.self)
  }
  
  /// Visit a ``PrefixOperatorExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrefixOperatorExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``PrimaryAssociatedTypeClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrimaryAssociatedTypeClauseSyntax) -> PrimaryAssociatedTypeClauseSyntax {
    return Syntax(visitChildren(node)).cast(PrimaryAssociatedTypeClauseSyntax.self)
  }
  
  /// Visit a ``PrimaryAssociatedTypeListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrimaryAssociatedTypeListSyntax) -> PrimaryAssociatedTypeListSyntax {
    return Syntax(visitChildren(node)).cast(PrimaryAssociatedTypeListSyntax.self)
  }
  
  /// Visit a ``PrimaryAssociatedTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: PrimaryAssociatedTypeSyntax) -> PrimaryAssociatedTypeSyntax {
    return Syntax(visitChildren(node)).cast(PrimaryAssociatedTypeSyntax.self)
  }
  
  /// Visit a ``ProtocolDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ProtocolDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``RegexLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: RegexLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``RepeatStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: RepeatStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``ReturnClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ReturnClauseSyntax) -> ReturnClauseSyntax {
    return Syntax(visitChildren(node)).cast(ReturnClauseSyntax.self)
  }
  
  /// Visit a ``ReturnStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ReturnStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``SameTypeRequirementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SameTypeRequirementSyntax) -> SameTypeRequirementSyntax {
    return Syntax(visitChildren(node)).cast(SameTypeRequirementSyntax.self)
  }
  
  /// Visit a ``SequenceExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SequenceExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``SimpleStringLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SimpleStringLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``SimpleStringLiteralSegmentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SimpleStringLiteralSegmentListSyntax) -> SimpleStringLiteralSegmentListSyntax {
    return Syntax(visitChildren(node)).cast(SimpleStringLiteralSegmentListSyntax.self)
  }
  
  /// Visit a ``SomeOrAnyTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SomeOrAnyTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``SourceFileSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SourceFileSyntax) -> SourceFileSyntax {
    return Syntax(visitChildren(node)).cast(SourceFileSyntax.self)
  }
  
  /// Visit a ``SpecializeAttributeArgumentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SpecializeAttributeArgumentListSyntax) -> SpecializeAttributeArgumentListSyntax {
    return Syntax(visitChildren(node)).cast(SpecializeAttributeArgumentListSyntax.self)
  }
  
  /// Visit a ``SpecializeAvailabilityArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SpecializeAvailabilityArgumentSyntax) -> SpecializeAvailabilityArgumentSyntax {
    return Syntax(visitChildren(node)).cast(SpecializeAvailabilityArgumentSyntax.self)
  }
  
  /// Visit a ``SpecializeTargetFunctionArgumentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SpecializeTargetFunctionArgumentSyntax) -> SpecializeTargetFunctionArgumentSyntax {
    return Syntax(visitChildren(node)).cast(SpecializeTargetFunctionArgumentSyntax.self)
  }
  
  /// Visit a ``StringLiteralExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: StringLiteralExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``StringLiteralSegmentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: StringLiteralSegmentListSyntax) -> StringLiteralSegmentListSyntax {
    return Syntax(visitChildren(node)).cast(StringLiteralSegmentListSyntax.self)
  }
  
  /// Visit a ``StringSegmentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: StringSegmentSyntax) -> StringSegmentSyntax {
    return Syntax(visitChildren(node)).cast(StringSegmentSyntax.self)
  }
  
  /// Visit a ``StructDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: StructDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``SubscriptCallExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SubscriptCallExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``SubscriptDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SubscriptDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``SuperExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SuperExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``SuppressedTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SuppressedTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``SwitchCaseItemListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchCaseItemListSyntax) -> SwitchCaseItemListSyntax {
    return Syntax(visitChildren(node)).cast(SwitchCaseItemListSyntax.self)
  }
  
  /// Visit a ``SwitchCaseItemSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchCaseItemSyntax) -> SwitchCaseItemSyntax {
    return Syntax(visitChildren(node)).cast(SwitchCaseItemSyntax.self)
  }
  
  /// Visit a ``SwitchCaseLabelSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchCaseLabelSyntax) -> SwitchCaseLabelSyntax {
    return Syntax(visitChildren(node)).cast(SwitchCaseLabelSyntax.self)
  }
  
  /// Visit a ``SwitchCaseListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchCaseListSyntax) -> SwitchCaseListSyntax {
    return Syntax(visitChildren(node)).cast(SwitchCaseListSyntax.self)
  }
  
  /// Visit a ``SwitchCaseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchCaseSyntax) -> SwitchCaseSyntax {
    return Syntax(visitChildren(node)).cast(SwitchCaseSyntax.self)
  }
  
  /// Visit a ``SwitchDefaultLabelSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchDefaultLabelSyntax) -> SwitchDefaultLabelSyntax {
    return Syntax(visitChildren(node)).cast(SwitchDefaultLabelSyntax.self)
  }
  
  /// Visit a ``SwitchExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: SwitchExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``TernaryExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TernaryExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ThrowStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ThrowStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``TryExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TryExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``TupleExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TupleExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``TuplePatternElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TuplePatternElementListSyntax) -> TuplePatternElementListSyntax {
    return Syntax(visitChildren(node)).cast(TuplePatternElementListSyntax.self)
  }
  
  /// Visit a ``TuplePatternElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TuplePatternElementSyntax) -> TuplePatternElementSyntax {
    return Syntax(visitChildren(node)).cast(TuplePatternElementSyntax.self)
  }
  
  /// Visit a ``TuplePatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TuplePatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``TupleTypeElementListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TupleTypeElementListSyntax) -> TupleTypeElementListSyntax {
    return Syntax(visitChildren(node)).cast(TupleTypeElementListSyntax.self)
  }
  
  /// Visit a ``TupleTypeElementSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TupleTypeElementSyntax) -> TupleTypeElementSyntax {
    return Syntax(visitChildren(node)).cast(TupleTypeElementSyntax.self)
  }
  
  /// Visit a ``TupleTypeSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TupleTypeSyntax) -> TypeSyntax {
    return TypeSyntax(visitChildren(node))
  }
  
  /// Visit a ``TypeAliasDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TypeAliasDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``TypeAnnotationSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TypeAnnotationSyntax) -> TypeAnnotationSyntax {
    return Syntax(visitChildren(node)).cast(TypeAnnotationSyntax.self)
  }
  
  /// Visit a ``TypeEffectSpecifiersSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TypeEffectSpecifiersSyntax) -> TypeEffectSpecifiersSyntax {
    return Syntax(visitChildren(node)).cast(TypeEffectSpecifiersSyntax.self)
  }
  
  /// Visit a ``TypeExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TypeExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``TypeInitializerClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: TypeInitializerClauseSyntax) -> TypeInitializerClauseSyntax {
    return Syntax(visitChildren(node)).cast(TypeInitializerClauseSyntax.self)
  }
  
  /// Visit a ``UnavailableFromAsyncAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: UnavailableFromAsyncAttributeArgumentsSyntax) -> UnavailableFromAsyncAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(UnavailableFromAsyncAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``UnderscorePrivateAttributeArgumentsSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: UnderscorePrivateAttributeArgumentsSyntax) -> UnderscorePrivateAttributeArgumentsSyntax {
    return Syntax(visitChildren(node)).cast(UnderscorePrivateAttributeArgumentsSyntax.self)
  }
  
  /// Visit a ``UnexpectedNodesSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: UnexpectedNodesSyntax) -> UnexpectedNodesSyntax {
    return Syntax(visitChildren(node)).cast(UnexpectedNodesSyntax.self)
  }
  
  /// Visit a ``UnresolvedAsExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: UnresolvedAsExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``UnresolvedIsExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: UnresolvedIsExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``UnresolvedTernaryExprSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: UnresolvedTernaryExprSyntax) -> ExprSyntax {
    return ExprSyntax(visitChildren(node))
  }
  
  /// Visit a ``ValueBindingPatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: ValueBindingPatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``VariableDeclSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: VariableDeclSyntax) -> DeclSyntax {
    return DeclSyntax(visitChildren(node))
  }
  
  /// Visit a ``VersionComponentListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: VersionComponentListSyntax) -> VersionComponentListSyntax {
    return Syntax(visitChildren(node)).cast(VersionComponentListSyntax.self)
  }
  
  /// Visit a ``VersionComponentSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: VersionComponentSyntax) -> VersionComponentSyntax {
    return Syntax(visitChildren(node)).cast(VersionComponentSyntax.self)
  }
  
  /// Visit a ``VersionTupleSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: VersionTupleSyntax) -> VersionTupleSyntax {
    return Syntax(visitChildren(node)).cast(VersionTupleSyntax.self)
  }
  
  /// Visit a ``WhereClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: WhereClauseSyntax) -> WhereClauseSyntax {
    return Syntax(visitChildren(node)).cast(WhereClauseSyntax.self)
  }
  
  /// Visit a ``WhileStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: WhileStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``WildcardPatternSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: WildcardPatternSyntax) -> PatternSyntax {
    return PatternSyntax(visitChildren(node))
  }
  
  /// Visit a ``YieldStmtSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: YieldStmtSyntax) -> StmtSyntax {
    return StmtSyntax(visitChildren(node))
  }
  
  /// Visit a ``YieldedExpressionListSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: YieldedExpressionListSyntax) -> YieldedExpressionListSyntax {
    return Syntax(visitChildren(node)).cast(YieldedExpressionListSyntax.self)
  }
  
  /// Visit a ``YieldedExpressionSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: YieldedExpressionSyntax) -> YieldedExpressionSyntax {
    return Syntax(visitChildren(node)).cast(YieldedExpressionSyntax.self)
  }
  
  /// Visit a ``YieldedExpressionsClauseSyntax``.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  open func visit(_ node: YieldedExpressionsClauseSyntax) -> YieldedExpressionsClauseSyntax {
    return Syntax(visitChildren(node)).cast(YieldedExpressionsClauseSyntax.self)
  }
  
  /// Visit any DeclSyntax node.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  public func visit(_ node: DeclSyntax) -> DeclSyntax {
    return visit(node.data).cast(DeclSyntax.self)
  }
  
  /// Visit any ExprSyntax node.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  public func visit(_ node: ExprSyntax) -> ExprSyntax {
    return visit(node.data).cast(ExprSyntax.self)
  }
  
  /// Visit any PatternSyntax node.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  public func visit(_ node: PatternSyntax) -> PatternSyntax {
    return visit(node.data).cast(PatternSyntax.self)
  }
  
  /// Visit any StmtSyntax node.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  public func visit(_ node: StmtSyntax) -> StmtSyntax {
    return visit(node.data).cast(StmtSyntax.self)
  }
  
  /// Visit any TypeSyntax node.
  ///   - Parameter node: the node that is being visited
  ///   - Returns: the rewritten node
  public func visit(_ node: TypeSyntax) -> TypeSyntax {
    return visit(node.data).cast(TypeSyntax.self)
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAccessorBlockSyntax(_ data: SyntaxData) -> Syntax {
    let node = AccessorBlockSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAccessorDeclListSyntax(_ data: SyntaxData) -> Syntax {
    let node = AccessorDeclListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAccessorDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = AccessorDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAccessorEffectSpecifiersSyntax(_ data: SyntaxData) -> Syntax {
    let node = AccessorEffectSpecifiersSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAccessorParametersSyntax(_ data: SyntaxData) -> Syntax {
    let node = AccessorParametersSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplActorDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = ActorDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplArrayElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ArrayElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplArrayElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = ArrayElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplArrayExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = ArrayExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplArrayTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = ArrayTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplArrowExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = ArrowExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAsExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = AsExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAssignmentExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = AssignmentExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAssociatedTypeDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = AssociatedTypeDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAttributeListSyntax(_ data: SyntaxData) -> Syntax {
    let node = AttributeListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAttributeSyntax(_ data: SyntaxData) -> Syntax {
    let node = AttributeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAttributedTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = AttributedTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAvailabilityArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = AvailabilityArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAvailabilityArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = AvailabilityArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAvailabilityConditionSyntax(_ data: SyntaxData) -> Syntax {
    let node = AvailabilityConditionSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAvailabilityLabeledArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = AvailabilityLabeledArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplAwaitExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = AwaitExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplBackDeployedAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = BackDeployedAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplBinaryOperatorExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = BinaryOperatorExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplBooleanLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = BooleanLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplBorrowExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = BorrowExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplBreakStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = BreakStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCanImportExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = CanImportExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCanImportVersionInfoSyntax(_ data: SyntaxData) -> Syntax {
    let node = CanImportVersionInfoSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCatchClauseListSyntax(_ data: SyntaxData) -> Syntax {
    let node = CatchClauseListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCatchClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = CatchClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCatchItemListSyntax(_ data: SyntaxData) -> Syntax {
    let node = CatchItemListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCatchItemSyntax(_ data: SyntaxData) -> Syntax {
    let node = CatchItemSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClassDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClassDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClassRestrictionTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClassRestrictionTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureCaptureClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureCaptureClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureCaptureListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureCaptureListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureCaptureSpecifierSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureCaptureSpecifierSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureCaptureSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureCaptureSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureParameterClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureParameterClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureParameterListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureParameterListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureParameterSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureParameterSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureShorthandParameterListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureShorthandParameterListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureShorthandParameterSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureShorthandParameterSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplClosureSignatureSyntax(_ data: SyntaxData) -> Syntax {
    let node = ClosureSignatureSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCodeBlockItemListSyntax(_ data: SyntaxData) -> Syntax {
    let node = CodeBlockItemListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCodeBlockItemSyntax(_ data: SyntaxData) -> Syntax {
    let node = CodeBlockItemSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCodeBlockSyntax(_ data: SyntaxData) -> Syntax {
    let node = CodeBlockSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCompositionTypeElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = CompositionTypeElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCompositionTypeElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = CompositionTypeElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCompositionTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = CompositionTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplConditionElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ConditionElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplConditionElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = ConditionElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplConformanceRequirementSyntax(_ data: SyntaxData) -> Syntax {
    let node = ConformanceRequirementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplConsumeExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = ConsumeExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplContinueStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = ContinueStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplConventionAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = ConventionAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplConventionWitnessMethodAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = ConventionWitnessMethodAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplCopyExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = CopyExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclModifierDetailSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclModifierDetailSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclModifierListSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclModifierListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclModifierSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclModifierSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclNameArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclNameArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclNameArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclNameArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclNameArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclNameArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeclReferenceExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeclReferenceExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeferStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeferStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeinitializerDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeinitializerDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDeinitializerEffectSpecifiersSyntax(_ data: SyntaxData) -> Syntax {
    let node = DeinitializerEffectSpecifiersSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDerivativeAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = DerivativeAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDesignatedTypeListSyntax(_ data: SyntaxData) -> Syntax {
    let node = DesignatedTypeListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDesignatedTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = DesignatedTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDictionaryElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = DictionaryElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDictionaryElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = DictionaryElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDictionaryExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = DictionaryExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDictionaryTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = DictionaryTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDifferentiabilityArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = DifferentiabilityArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDifferentiabilityArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = DifferentiabilityArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDifferentiabilityArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = DifferentiabilityArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDifferentiabilityWithRespectToArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = DifferentiabilityWithRespectToArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDifferentiableAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = DifferentiableAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDiscardAssignmentExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = DiscardAssignmentExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDiscardStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = DiscardStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDoStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = DoStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDocumentationAttributeArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = DocumentationAttributeArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDocumentationAttributeArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = DocumentationAttributeArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplDynamicReplacementAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = DynamicReplacementAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEditorPlaceholderDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = EditorPlaceholderDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEditorPlaceholderExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = EditorPlaceholderExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEffectsAttributeArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = EffectsAttributeArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumCaseDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumCaseDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumCaseElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumCaseElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumCaseElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumCaseElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumCaseParameterClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumCaseParameterClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumCaseParameterListSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumCaseParameterListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumCaseParameterSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumCaseParameterSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplEnumDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = EnumDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplExposeAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = ExposeAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplExprListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ExprListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplExpressionPatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = ExpressionPatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplExpressionSegmentSyntax(_ data: SyntaxData) -> Syntax {
    let node = ExpressionSegmentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplExpressionStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = ExpressionStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplExtensionDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = ExtensionDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFallThroughStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = FallThroughStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFloatLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = FloatLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplForStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = ForStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplForceUnwrapExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = ForceUnwrapExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionCallExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionCallExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionEffectSpecifiersSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionEffectSpecifiersSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionParameterClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionParameterClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionParameterListSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionParameterListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionParameterSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionParameterSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionSignatureSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionSignatureSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplFunctionTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = FunctionTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericArgumentClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericArgumentClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericParameterClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericParameterClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericParameterListSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericParameterListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericParameterSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericParameterSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericRequirementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericRequirementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericRequirementSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericRequirementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericSpecializationExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericSpecializationExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGenericWhereClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = GenericWhereClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplGuardStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = GuardStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIdentifierPatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = IdentifierPatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIdentifierTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = IdentifierTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIfConfigClauseListSyntax(_ data: SyntaxData) -> Syntax {
    let node = IfConfigClauseListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIfConfigClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = IfConfigClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIfConfigDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = IfConfigDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIfExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = IfExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplImplementsAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = ImplementsAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplImplicitlyUnwrappedOptionalTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = ImplicitlyUnwrappedOptionalTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplImportDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = ImportDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplImportPathComponentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ImportPathComponentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplImportPathComponentSyntax(_ data: SyntaxData) -> Syntax {
    let node = ImportPathComponentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInOutExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = InOutExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInfixOperatorExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = InfixOperatorExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInheritanceClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = InheritanceClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInheritedTypeListSyntax(_ data: SyntaxData) -> Syntax {
    let node = InheritedTypeListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInheritedTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = InheritedTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInitializerClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = InitializerClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplInitializerDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = InitializerDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIntegerLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = IntegerLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIsExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = IsExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplIsTypePatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = IsTypePatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplKeyPathComponentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = KeyPathComponentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplKeyPathComponentSyntax(_ data: SyntaxData) -> Syntax {
    let node = KeyPathComponentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplKeyPathExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = KeyPathExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplKeyPathOptionalComponentSyntax(_ data: SyntaxData) -> Syntax {
    let node = KeyPathOptionalComponentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplKeyPathPropertyComponentSyntax(_ data: SyntaxData) -> Syntax {
    let node = KeyPathPropertyComponentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplKeyPathSubscriptComponentSyntax(_ data: SyntaxData) -> Syntax {
    let node = KeyPathSubscriptComponentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplLabeledExprListSyntax(_ data: SyntaxData) -> Syntax {
    let node = LabeledExprListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplLabeledExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = LabeledExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplLabeledSpecializeArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = LabeledSpecializeArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplLabeledStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = LabeledStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplLayoutRequirementSyntax(_ data: SyntaxData) -> Syntax {
    let node = LayoutRequirementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMacroDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = MacroDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMacroExpansionDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = MacroExpansionDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMacroExpansionExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = MacroExpansionExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMatchingPatternConditionSyntax(_ data: SyntaxData) -> Syntax {
    let node = MatchingPatternConditionSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMemberAccessExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = MemberAccessExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMemberBlockItemListSyntax(_ data: SyntaxData) -> Syntax {
    let node = MemberBlockItemListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMemberBlockItemSyntax(_ data: SyntaxData) -> Syntax {
    let node = MemberBlockItemSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMemberBlockSyntax(_ data: SyntaxData) -> Syntax {
    let node = MemberBlockSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMemberTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = MemberTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMetatypeTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = MetatypeTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMissingDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = MissingDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMissingExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = MissingExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMissingPatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = MissingPatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMissingStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = MissingStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMissingSyntax(_ data: SyntaxData) -> Syntax {
    let node = MissingSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMissingTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = MissingTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMultipleTrailingClosureElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = MultipleTrailingClosureElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplMultipleTrailingClosureElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = MultipleTrailingClosureElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplNamedOpaqueReturnTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = NamedOpaqueReturnTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplNilLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = NilLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplObjCSelectorPieceListSyntax(_ data: SyntaxData) -> Syntax {
    let node = ObjCSelectorPieceListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplObjCSelectorPieceSyntax(_ data: SyntaxData) -> Syntax {
    let node = ObjCSelectorPieceSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOpaqueReturnTypeOfAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = OpaqueReturnTypeOfAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOperatorDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = OperatorDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOperatorPrecedenceAndTypesSyntax(_ data: SyntaxData) -> Syntax {
    let node = OperatorPrecedenceAndTypesSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOptionalBindingConditionSyntax(_ data: SyntaxData) -> Syntax {
    let node = OptionalBindingConditionSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOptionalChainingExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = OptionalChainingExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOptionalTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = OptionalTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplOriginallyDefinedInAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = OriginallyDefinedInAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPackElementExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = PackElementExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPackElementTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = PackElementTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPackExpansionExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = PackExpansionExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPackExpansionTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = PackExpansionTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPatternBindingListSyntax(_ data: SyntaxData) -> Syntax {
    let node = PatternBindingListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPatternBindingSyntax(_ data: SyntaxData) -> Syntax {
    let node = PatternBindingSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPatternExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = PatternExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPlatformVersionItemListSyntax(_ data: SyntaxData) -> Syntax {
    let node = PlatformVersionItemListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPlatformVersionItemSyntax(_ data: SyntaxData) -> Syntax {
    let node = PlatformVersionItemSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPlatformVersionSyntax(_ data: SyntaxData) -> Syntax {
    let node = PlatformVersionSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPostfixIfConfigExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = PostfixIfConfigExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPostfixOperatorExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = PostfixOperatorExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPoundSourceLocationArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = PoundSourceLocationArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPoundSourceLocationSyntax(_ data: SyntaxData) -> Syntax {
    let node = PoundSourceLocationSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupAssignmentSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupAssignmentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupAssociativitySyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupAssociativitySyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupAttributeListSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupAttributeListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupNameListSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupNameListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupNameSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupNameSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrecedenceGroupRelationSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrecedenceGroupRelationSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrefixOperatorExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrefixOperatorExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrimaryAssociatedTypeClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrimaryAssociatedTypeClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrimaryAssociatedTypeListSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrimaryAssociatedTypeListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplPrimaryAssociatedTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = PrimaryAssociatedTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplProtocolDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = ProtocolDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplRegexLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = RegexLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplRepeatStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = RepeatStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplReturnClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = ReturnClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplReturnStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = ReturnStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSameTypeRequirementSyntax(_ data: SyntaxData) -> Syntax {
    let node = SameTypeRequirementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSequenceExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = SequenceExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSimpleStringLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = SimpleStringLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSimpleStringLiteralSegmentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = SimpleStringLiteralSegmentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSomeOrAnyTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = SomeOrAnyTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSourceFileSyntax(_ data: SyntaxData) -> Syntax {
    let node = SourceFileSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSpecializeAttributeArgumentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = SpecializeAttributeArgumentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSpecializeAvailabilityArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = SpecializeAvailabilityArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSpecializeTargetFunctionArgumentSyntax(_ data: SyntaxData) -> Syntax {
    let node = SpecializeTargetFunctionArgumentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplStringLiteralExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = StringLiteralExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplStringLiteralSegmentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = StringLiteralSegmentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplStringSegmentSyntax(_ data: SyntaxData) -> Syntax {
    let node = StringSegmentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplStructDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = StructDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSubscriptCallExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = SubscriptCallExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSubscriptDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = SubscriptDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSuperExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = SuperExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSuppressedTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = SuppressedTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchCaseItemListSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchCaseItemListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchCaseItemSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchCaseItemSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchCaseLabelSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchCaseLabelSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchCaseListSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchCaseListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchCaseSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchCaseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchDefaultLabelSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchDefaultLabelSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplSwitchExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = SwitchExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTernaryExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = TernaryExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplThrowStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = ThrowStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTryExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = TryExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTupleExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = TupleExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTuplePatternElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = TuplePatternElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTuplePatternElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = TuplePatternElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTuplePatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = TuplePatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTupleTypeElementListSyntax(_ data: SyntaxData) -> Syntax {
    let node = TupleTypeElementListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTupleTypeElementSyntax(_ data: SyntaxData) -> Syntax {
    let node = TupleTypeElementSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTupleTypeSyntax(_ data: SyntaxData) -> Syntax {
    let node = TupleTypeSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTypeAliasDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = TypeAliasDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTypeAnnotationSyntax(_ data: SyntaxData) -> Syntax {
    let node = TypeAnnotationSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTypeEffectSpecifiersSyntax(_ data: SyntaxData) -> Syntax {
    let node = TypeEffectSpecifiersSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTypeExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = TypeExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTypeInitializerClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = TypeInitializerClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplUnavailableFromAsyncAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = UnavailableFromAsyncAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplUnderscorePrivateAttributeArgumentsSyntax(_ data: SyntaxData) -> Syntax {
    let node = UnderscorePrivateAttributeArgumentsSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplUnexpectedNodesSyntax(_ data: SyntaxData) -> Syntax {
    let node = UnexpectedNodesSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplUnresolvedAsExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = UnresolvedAsExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplUnresolvedIsExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = UnresolvedIsExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplUnresolvedTernaryExprSyntax(_ data: SyntaxData) -> Syntax {
    let node = UnresolvedTernaryExprSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplValueBindingPatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = ValueBindingPatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplVariableDeclSyntax(_ data: SyntaxData) -> Syntax {
    let node = VariableDeclSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplVersionComponentListSyntax(_ data: SyntaxData) -> Syntax {
    let node = VersionComponentListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplVersionComponentSyntax(_ data: SyntaxData) -> Syntax {
    let node = VersionComponentSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplVersionTupleSyntax(_ data: SyntaxData) -> Syntax {
    let node = VersionTupleSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplWhereClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = WhereClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplWhileStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = WhileStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplWildcardPatternSyntax(_ data: SyntaxData) -> Syntax {
    let node = WildcardPatternSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplYieldStmtSyntax(_ data: SyntaxData) -> Syntax {
    let node = YieldStmtSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplYieldedExpressionListSyntax(_ data: SyntaxData) -> Syntax {
    let node = YieldedExpressionListSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplYieldedExpressionSyntax(_ data: SyntaxData) -> Syntax {
    let node = YieldedExpressionSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplYieldedExpressionsClauseSyntax(_ data: SyntaxData) -> Syntax {
    let node = YieldedExpressionsClauseSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  /// Implementation detail of visit(_:). Do not call directly.
  private func visitImplTokenSyntax(_ data: SyntaxData) -> Syntax {
    let node = TokenSyntax(data)
    // Accessing _syntaxNode directly is faster than calling Syntax(node)
    visitPre(node._syntaxNode)
    defer {
      visitPost(node._syntaxNode)
    }
    if let newNode = visitAny(node._syntaxNode) {
      return newNode
    }
    return Syntax(visit(node))
  }
  
  // SwiftSyntax requires a lot of stack space in debug builds for syntax tree
  // rewriting. In scenarios with reduced stack space (in particular dispatch
  // queues), this easily results in a stack overflow. To work around this issue,
  // use a less performant but also less stack-hungry version of SwiftSyntax's
  // SyntaxRewriter in debug builds.
  #if DEBUG
  /// Implementation detail of visit(_:). Do not call directly.
  ///
  /// Returns the function that shall be called to visit a specific syntax node.
  ///
  /// To determine the correct specific visitation function for a syntax node,
  /// we need to switch through a huge switch statement that covers all syntax
  /// types. In debug builds, the cases of this switch statement do not share
  /// stack space (rdar://55929175). Because of this, the switch statement
  /// requires allocates about 15KB of stack space. In scenarios with reduced
  /// stack size (in particular dispatch queues), this often results in a stack
  /// overflow during syntax tree rewriting.
  ///
  /// To circumvent this problem, make calling the specific visitation function
  /// a two-step process: First determine the function to call in this function
  /// and return a reference to it, then call it. This way, the stack frame
  /// that determines the correct visitation function will be popped of the
  /// stack before the function is being called, making the switch's stack
  /// space transient instead of having it linger in the call stack.
  private func visitationFunc(for data: SyntaxData) -> ((SyntaxData) -> Syntax) {
    switch data.raw.kind {
    case .token:
      return visitImplTokenSyntax
    case .accessorBlock:
      return visitImplAccessorBlockSyntax
    case .accessorDeclList:
      return visitImplAccessorDeclListSyntax
    case .accessorDecl:
      return visitImplAccessorDeclSyntax
    case .accessorEffectSpecifiers:
      return visitImplAccessorEffectSpecifiersSyntax
    case .accessorParameters:
      return visitImplAccessorParametersSyntax
    case .actorDecl:
      return visitImplActorDeclSyntax
    case .arrayElementList:
      return visitImplArrayElementListSyntax
    case .arrayElement:
      return visitImplArrayElementSyntax
    case .arrayExpr:
      return visitImplArrayExprSyntax
    case .arrayType:
      return visitImplArrayTypeSyntax
    case .arrowExpr:
      return visitImplArrowExprSyntax
    case .asExpr:
      return visitImplAsExprSyntax
    case .assignmentExpr:
      return visitImplAssignmentExprSyntax
    case .associatedTypeDecl:
      return visitImplAssociatedTypeDeclSyntax
    case .attributeList:
      return visitImplAttributeListSyntax
    case .attribute:
      return visitImplAttributeSyntax
    case .attributedType:
      return visitImplAttributedTypeSyntax
    case .availabilityArgumentList:
      return visitImplAvailabilityArgumentListSyntax
    case .availabilityArgument:
      return visitImplAvailabilityArgumentSyntax
    case .availabilityCondition:
      return visitImplAvailabilityConditionSyntax
    case .availabilityLabeledArgument:
      return visitImplAvailabilityLabeledArgumentSyntax
    case .awaitExpr:
      return visitImplAwaitExprSyntax
    case .backDeployedAttributeArguments:
      return visitImplBackDeployedAttributeArgumentsSyntax
    case .binaryOperatorExpr:
      return visitImplBinaryOperatorExprSyntax
    case .booleanLiteralExpr:
      return visitImplBooleanLiteralExprSyntax
    case .borrowExpr:
      return visitImplBorrowExprSyntax
    case .breakStmt:
      return visitImplBreakStmtSyntax
    case .canImportExpr:
      return visitImplCanImportExprSyntax
    case .canImportVersionInfo:
      return visitImplCanImportVersionInfoSyntax
    case .catchClauseList:
      return visitImplCatchClauseListSyntax
    case .catchClause:
      return visitImplCatchClauseSyntax
    case .catchItemList:
      return visitImplCatchItemListSyntax
    case .catchItem:
      return visitImplCatchItemSyntax
    case .classDecl:
      return visitImplClassDeclSyntax
    case .classRestrictionType:
      return visitImplClassRestrictionTypeSyntax
    case .closureCaptureClause:
      return visitImplClosureCaptureClauseSyntax
    case .closureCaptureList:
      return visitImplClosureCaptureListSyntax
    case .closureCaptureSpecifier:
      return visitImplClosureCaptureSpecifierSyntax
    case .closureCapture:
      return visitImplClosureCaptureSyntax
    case .closureExpr:
      return visitImplClosureExprSyntax
    case .closureParameterClause:
      return visitImplClosureParameterClauseSyntax
    case .closureParameterList:
      return visitImplClosureParameterListSyntax
    case .closureParameter:
      return visitImplClosureParameterSyntax
    case .closureShorthandParameterList:
      return visitImplClosureShorthandParameterListSyntax
    case .closureShorthandParameter:
      return visitImplClosureShorthandParameterSyntax
    case .closureSignature:
      return visitImplClosureSignatureSyntax
    case .codeBlockItemList:
      return visitImplCodeBlockItemListSyntax
    case .codeBlockItem:
      return visitImplCodeBlockItemSyntax
    case .codeBlock:
      return visitImplCodeBlockSyntax
    case .compositionTypeElementList:
      return visitImplCompositionTypeElementListSyntax
    case .compositionTypeElement:
      return visitImplCompositionTypeElementSyntax
    case .compositionType:
      return visitImplCompositionTypeSyntax
    case .conditionElementList:
      return visitImplConditionElementListSyntax
    case .conditionElement:
      return visitImplConditionElementSyntax
    case .conformanceRequirement:
      return visitImplConformanceRequirementSyntax
    case .consumeExpr:
      return visitImplConsumeExprSyntax
    case .continueStmt:
      return visitImplContinueStmtSyntax
    case .conventionAttributeArguments:
      return visitImplConventionAttributeArgumentsSyntax
    case .conventionWitnessMethodAttributeArguments:
      return visitImplConventionWitnessMethodAttributeArgumentsSyntax
    case .copyExpr:
      return visitImplCopyExprSyntax
    case .declModifierDetail:
      return visitImplDeclModifierDetailSyntax
    case .declModifierList:
      return visitImplDeclModifierListSyntax
    case .declModifier:
      return visitImplDeclModifierSyntax
    case .declNameArgumentList:
      return visitImplDeclNameArgumentListSyntax
    case .declNameArgument:
      return visitImplDeclNameArgumentSyntax
    case .declNameArguments:
      return visitImplDeclNameArgumentsSyntax
    case .declReferenceExpr:
      return visitImplDeclReferenceExprSyntax
    case .deferStmt:
      return visitImplDeferStmtSyntax
    case .deinitializerDecl:
      return visitImplDeinitializerDeclSyntax
    case .deinitializerEffectSpecifiers:
      return visitImplDeinitializerEffectSpecifiersSyntax
    case .derivativeAttributeArguments:
      return visitImplDerivativeAttributeArgumentsSyntax
    case .designatedTypeList:
      return visitImplDesignatedTypeListSyntax
    case .designatedType:
      return visitImplDesignatedTypeSyntax
    case .dictionaryElementList:
      return visitImplDictionaryElementListSyntax
    case .dictionaryElement:
      return visitImplDictionaryElementSyntax
    case .dictionaryExpr:
      return visitImplDictionaryExprSyntax
    case .dictionaryType:
      return visitImplDictionaryTypeSyntax
    case .differentiabilityArgumentList:
      return visitImplDifferentiabilityArgumentListSyntax
    case .differentiabilityArgument:
      return visitImplDifferentiabilityArgumentSyntax
    case .differentiabilityArguments:
      return visitImplDifferentiabilityArgumentsSyntax
    case .differentiabilityWithRespectToArgument:
      return visitImplDifferentiabilityWithRespectToArgumentSyntax
    case .differentiableAttributeArguments:
      return visitImplDifferentiableAttributeArgumentsSyntax
    case .discardAssignmentExpr:
      return visitImplDiscardAssignmentExprSyntax
    case .discardStmt:
      return visitImplDiscardStmtSyntax
    case .doStmt:
      return visitImplDoStmtSyntax
    case .documentationAttributeArgumentList:
      return visitImplDocumentationAttributeArgumentListSyntax
    case .documentationAttributeArgument:
      return visitImplDocumentationAttributeArgumentSyntax
    case .dynamicReplacementAttributeArguments:
      return visitImplDynamicReplacementAttributeArgumentsSyntax
    case .editorPlaceholderDecl:
      return visitImplEditorPlaceholderDeclSyntax
    case .editorPlaceholderExpr:
      return visitImplEditorPlaceholderExprSyntax
    case .effectsAttributeArgumentList:
      return visitImplEffectsAttributeArgumentListSyntax
    case .enumCaseDecl:
      return visitImplEnumCaseDeclSyntax
    case .enumCaseElementList:
      return visitImplEnumCaseElementListSyntax
    case .enumCaseElement:
      return visitImplEnumCaseElementSyntax
    case .enumCaseParameterClause:
      return visitImplEnumCaseParameterClauseSyntax
    case .enumCaseParameterList:
      return visitImplEnumCaseParameterListSyntax
    case .enumCaseParameter:
      return visitImplEnumCaseParameterSyntax
    case .enumDecl:
      return visitImplEnumDeclSyntax
    case .exposeAttributeArguments:
      return visitImplExposeAttributeArgumentsSyntax
    case .exprList:
      return visitImplExprListSyntax
    case .expressionPattern:
      return visitImplExpressionPatternSyntax
    case .expressionSegment:
      return visitImplExpressionSegmentSyntax
    case .expressionStmt:
      return visitImplExpressionStmtSyntax
    case .extensionDecl:
      return visitImplExtensionDeclSyntax
    case .fallThroughStmt:
      return visitImplFallThroughStmtSyntax
    case .floatLiteralExpr:
      return visitImplFloatLiteralExprSyntax
    case .forStmt:
      return visitImplForStmtSyntax
    case .forceUnwrapExpr:
      return visitImplForceUnwrapExprSyntax
    case .functionCallExpr:
      return visitImplFunctionCallExprSyntax
    case .functionDecl:
      return visitImplFunctionDeclSyntax
    case .functionEffectSpecifiers:
      return visitImplFunctionEffectSpecifiersSyntax
    case .functionParameterClause:
      return visitImplFunctionParameterClauseSyntax
    case .functionParameterList:
      return visitImplFunctionParameterListSyntax
    case .functionParameter:
      return visitImplFunctionParameterSyntax
    case .functionSignature:
      return visitImplFunctionSignatureSyntax
    case .functionType:
      return visitImplFunctionTypeSyntax
    case .genericArgumentClause:
      return visitImplGenericArgumentClauseSyntax
    case .genericArgumentList:
      return visitImplGenericArgumentListSyntax
    case .genericArgument:
      return visitImplGenericArgumentSyntax
    case .genericParameterClause:
      return visitImplGenericParameterClauseSyntax
    case .genericParameterList:
      return visitImplGenericParameterListSyntax
    case .genericParameter:
      return visitImplGenericParameterSyntax
    case .genericRequirementList:
      return visitImplGenericRequirementListSyntax
    case .genericRequirement:
      return visitImplGenericRequirementSyntax
    case .genericSpecializationExpr:
      return visitImplGenericSpecializationExprSyntax
    case .genericWhereClause:
      return visitImplGenericWhereClauseSyntax
    case .guardStmt:
      return visitImplGuardStmtSyntax
    case .identifierPattern:
      return visitImplIdentifierPatternSyntax
    case .identifierType:
      return visitImplIdentifierTypeSyntax
    case .ifConfigClauseList:
      return visitImplIfConfigClauseListSyntax
    case .ifConfigClause:
      return visitImplIfConfigClauseSyntax
    case .ifConfigDecl:
      return visitImplIfConfigDeclSyntax
    case .ifExpr:
      return visitImplIfExprSyntax
    case .implementsAttributeArguments:
      return visitImplImplementsAttributeArgumentsSyntax
    case .implicitlyUnwrappedOptionalType:
      return visitImplImplicitlyUnwrappedOptionalTypeSyntax
    case .importDecl:
      return visitImplImportDeclSyntax
    case .importPathComponentList:
      return visitImplImportPathComponentListSyntax
    case .importPathComponent:
      return visitImplImportPathComponentSyntax
    case .inOutExpr:
      return visitImplInOutExprSyntax
    case .infixOperatorExpr:
      return visitImplInfixOperatorExprSyntax
    case .inheritanceClause:
      return visitImplInheritanceClauseSyntax
    case .inheritedTypeList:
      return visitImplInheritedTypeListSyntax
    case .inheritedType:
      return visitImplInheritedTypeSyntax
    case .initializerClause:
      return visitImplInitializerClauseSyntax
    case .initializerDecl:
      return visitImplInitializerDeclSyntax
    case .integerLiteralExpr:
      return visitImplIntegerLiteralExprSyntax
    case .isExpr:
      return visitImplIsExprSyntax
    case .isTypePattern:
      return visitImplIsTypePatternSyntax
    case .keyPathComponentList:
      return visitImplKeyPathComponentListSyntax
    case .keyPathComponent:
      return visitImplKeyPathComponentSyntax
    case .keyPathExpr:
      return visitImplKeyPathExprSyntax
    case .keyPathOptionalComponent:
      return visitImplKeyPathOptionalComponentSyntax
    case .keyPathPropertyComponent:
      return visitImplKeyPathPropertyComponentSyntax
    case .keyPathSubscriptComponent:
      return visitImplKeyPathSubscriptComponentSyntax
    case .labeledExprList:
      return visitImplLabeledExprListSyntax
    case .labeledExpr:
      return visitImplLabeledExprSyntax
    case .labeledSpecializeArgument:
      return visitImplLabeledSpecializeArgumentSyntax
    case .labeledStmt:
      return visitImplLabeledStmtSyntax
    case .layoutRequirement:
      return visitImplLayoutRequirementSyntax
    case .macroDecl:
      return visitImplMacroDeclSyntax
    case .macroExpansionDecl:
      return visitImplMacroExpansionDeclSyntax
    case .macroExpansionExpr:
      return visitImplMacroExpansionExprSyntax
    case .matchingPatternCondition:
      return visitImplMatchingPatternConditionSyntax
    case .memberAccessExpr:
      return visitImplMemberAccessExprSyntax
    case .memberBlockItemList:
      return visitImplMemberBlockItemListSyntax
    case .memberBlockItem:
      return visitImplMemberBlockItemSyntax
    case .memberBlock:
      return visitImplMemberBlockSyntax
    case .memberType:
      return visitImplMemberTypeSyntax
    case .metatypeType:
      return visitImplMetatypeTypeSyntax
    case .missingDecl:
      return visitImplMissingDeclSyntax
    case .missingExpr:
      return visitImplMissingExprSyntax
    case .missingPattern:
      return visitImplMissingPatternSyntax
    case .missingStmt:
      return visitImplMissingStmtSyntax
    case .missing:
      return visitImplMissingSyntax
    case .missingType:
      return visitImplMissingTypeSyntax
    case .multipleTrailingClosureElementList:
      return visitImplMultipleTrailingClosureElementListSyntax
    case .multipleTrailingClosureElement:
      return visitImplMultipleTrailingClosureElementSyntax
    case .namedOpaqueReturnType:
      return visitImplNamedOpaqueReturnTypeSyntax
    case .nilLiteralExpr:
      return visitImplNilLiteralExprSyntax
    case .objCSelectorPieceList:
      return visitImplObjCSelectorPieceListSyntax
    case .objCSelectorPiece:
      return visitImplObjCSelectorPieceSyntax
    case .opaqueReturnTypeOfAttributeArguments:
      return visitImplOpaqueReturnTypeOfAttributeArgumentsSyntax
    case .operatorDecl:
      return visitImplOperatorDeclSyntax
    case .operatorPrecedenceAndTypes:
      return visitImplOperatorPrecedenceAndTypesSyntax
    case .optionalBindingCondition:
      return visitImplOptionalBindingConditionSyntax
    case .optionalChainingExpr:
      return visitImplOptionalChainingExprSyntax
    case .optionalType:
      return visitImplOptionalTypeSyntax
    case .originallyDefinedInAttributeArguments:
      return visitImplOriginallyDefinedInAttributeArgumentsSyntax
    case .packElementExpr:
      return visitImplPackElementExprSyntax
    case .packElementType:
      return visitImplPackElementTypeSyntax
    case .packExpansionExpr:
      return visitImplPackExpansionExprSyntax
    case .packExpansionType:
      return visitImplPackExpansionTypeSyntax
    case .patternBindingList:
      return visitImplPatternBindingListSyntax
    case .patternBinding:
      return visitImplPatternBindingSyntax
    case .patternExpr:
      return visitImplPatternExprSyntax
    case .platformVersionItemList:
      return visitImplPlatformVersionItemListSyntax
    case .platformVersionItem:
      return visitImplPlatformVersionItemSyntax
    case .platformVersion:
      return visitImplPlatformVersionSyntax
    case .postfixIfConfigExpr:
      return visitImplPostfixIfConfigExprSyntax
    case .postfixOperatorExpr:
      return visitImplPostfixOperatorExprSyntax
    case .poundSourceLocationArguments:
      return visitImplPoundSourceLocationArgumentsSyntax
    case .poundSourceLocation:
      return visitImplPoundSourceLocationSyntax
    case .precedenceGroupAssignment:
      return visitImplPrecedenceGroupAssignmentSyntax
    case .precedenceGroupAssociativity:
      return visitImplPrecedenceGroupAssociativitySyntax
    case .precedenceGroupAttributeList:
      return visitImplPrecedenceGroupAttributeListSyntax
    case .precedenceGroupDecl:
      return visitImplPrecedenceGroupDeclSyntax
    case .precedenceGroupNameList:
      return visitImplPrecedenceGroupNameListSyntax
    case .precedenceGroupName:
      return visitImplPrecedenceGroupNameSyntax
    case .precedenceGroupRelation:
      return visitImplPrecedenceGroupRelationSyntax
    case .prefixOperatorExpr:
      return visitImplPrefixOperatorExprSyntax
    case .primaryAssociatedTypeClause:
      return visitImplPrimaryAssociatedTypeClauseSyntax
    case .primaryAssociatedTypeList:
      return visitImplPrimaryAssociatedTypeListSyntax
    case .primaryAssociatedType:
      return visitImplPrimaryAssociatedTypeSyntax
    case .protocolDecl:
      return visitImplProtocolDeclSyntax
    case .regexLiteralExpr:
      return visitImplRegexLiteralExprSyntax
    case .repeatStmt:
      return visitImplRepeatStmtSyntax
    case .returnClause:
      return visitImplReturnClauseSyntax
    case .returnStmt:
      return visitImplReturnStmtSyntax
    case .sameTypeRequirement:
      return visitImplSameTypeRequirementSyntax
    case .sequenceExpr:
      return visitImplSequenceExprSyntax
    case .simpleStringLiteralExpr:
      return visitImplSimpleStringLiteralExprSyntax
    case .simpleStringLiteralSegmentList:
      return visitImplSimpleStringLiteralSegmentListSyntax
    case .someOrAnyType:
      return visitImplSomeOrAnyTypeSyntax
    case .sourceFile:
      return visitImplSourceFileSyntax
    case .specializeAttributeArgumentList:
      return visitImplSpecializeAttributeArgumentListSyntax
    case .specializeAvailabilityArgument:
      return visitImplSpecializeAvailabilityArgumentSyntax
    case .specializeTargetFunctionArgument:
      return visitImplSpecializeTargetFunctionArgumentSyntax
    case .stringLiteralExpr:
      return visitImplStringLiteralExprSyntax
    case .stringLiteralSegmentList:
      return visitImplStringLiteralSegmentListSyntax
    case .stringSegment:
      return visitImplStringSegmentSyntax
    case .structDecl:
      return visitImplStructDeclSyntax
    case .subscriptCallExpr:
      return visitImplSubscriptCallExprSyntax
    case .subscriptDecl:
      return visitImplSubscriptDeclSyntax
    case .superExpr:
      return visitImplSuperExprSyntax
    case .suppressedType:
      return visitImplSuppressedTypeSyntax
    case .switchCaseItemList:
      return visitImplSwitchCaseItemListSyntax
    case .switchCaseItem:
      return visitImplSwitchCaseItemSyntax
    case .switchCaseLabel:
      return visitImplSwitchCaseLabelSyntax
    case .switchCaseList:
      return visitImplSwitchCaseListSyntax
    case .switchCase:
      return visitImplSwitchCaseSyntax
    case .switchDefaultLabel:
      return visitImplSwitchDefaultLabelSyntax
    case .switchExpr:
      return visitImplSwitchExprSyntax
    case .ternaryExpr:
      return visitImplTernaryExprSyntax
    case .throwStmt:
      return visitImplThrowStmtSyntax
    case .tryExpr:
      return visitImplTryExprSyntax
    case .tupleExpr:
      return visitImplTupleExprSyntax
    case .tuplePatternElementList:
      return visitImplTuplePatternElementListSyntax
    case .tuplePatternElement:
      return visitImplTuplePatternElementSyntax
    case .tuplePattern:
      return visitImplTuplePatternSyntax
    case .tupleTypeElementList:
      return visitImplTupleTypeElementListSyntax
    case .tupleTypeElement:
      return visitImplTupleTypeElementSyntax
    case .tupleType:
      return visitImplTupleTypeSyntax
    case .typeAliasDecl:
      return visitImplTypeAliasDeclSyntax
    case .typeAnnotation:
      return visitImplTypeAnnotationSyntax
    case .typeEffectSpecifiers:
      return visitImplTypeEffectSpecifiersSyntax
    case .typeExpr:
      return visitImplTypeExprSyntax
    case .typeInitializerClause:
      return visitImplTypeInitializerClauseSyntax
    case .unavailableFromAsyncAttributeArguments:
      return visitImplUnavailableFromAsyncAttributeArgumentsSyntax
    case .underscorePrivateAttributeArguments:
      return visitImplUnderscorePrivateAttributeArgumentsSyntax
    case .unexpectedNodes:
      return visitImplUnexpectedNodesSyntax
    case .unresolvedAsExpr:
      return visitImplUnresolvedAsExprSyntax
    case .unresolvedIsExpr:
      return visitImplUnresolvedIsExprSyntax
    case .unresolvedTernaryExpr:
      return visitImplUnresolvedTernaryExprSyntax
    case .valueBindingPattern:
      return visitImplValueBindingPatternSyntax
    case .variableDecl:
      return visitImplVariableDeclSyntax
    case .versionComponentList:
      return visitImplVersionComponentListSyntax
    case .versionComponent:
      return visitImplVersionComponentSyntax
    case .versionTuple:
      return visitImplVersionTupleSyntax
    case .whereClause:
      return visitImplWhereClauseSyntax
    case .whileStmt:
      return visitImplWhileStmtSyntax
    case .wildcardPattern:
      return visitImplWildcardPatternSyntax
    case .yieldStmt:
      return visitImplYieldStmtSyntax
    case .yieldedExpressionList:
      return visitImplYieldedExpressionListSyntax
    case .yieldedExpression:
      return visitImplYieldedExpressionSyntax
    case .yieldedExpressionsClause:
      return visitImplYieldedExpressionsClauseSyntax
    }
  }
  private func visit(_ data: SyntaxData) -> Syntax {
    return visitationFunc(for: data)(data)
  }
  #else
  private func visit(_ data: SyntaxData) -> Syntax {
    switch data.raw.kind {
    case .token:
      return visitImplTokenSyntax(data)
    case .accessorBlock:
      return visitImplAccessorBlockSyntax(data)
    case .accessorDeclList:
      return visitImplAccessorDeclListSyntax(data)
    case .accessorDecl:
      return visitImplAccessorDeclSyntax(data)
    case .accessorEffectSpecifiers:
      return visitImplAccessorEffectSpecifiersSyntax(data)
    case .accessorParameters:
      return visitImplAccessorParametersSyntax(data)
    case .actorDecl:
      return visitImplActorDeclSyntax(data)
    case .arrayElementList:
      return visitImplArrayElementListSyntax(data)
    case .arrayElement:
      return visitImplArrayElementSyntax(data)
    case .arrayExpr:
      return visitImplArrayExprSyntax(data)
    case .arrayType:
      return visitImplArrayTypeSyntax(data)
    case .arrowExpr:
      return visitImplArrowExprSyntax(data)
    case .asExpr:
      return visitImplAsExprSyntax(data)
    case .assignmentExpr:
      return visitImplAssignmentExprSyntax(data)
    case .associatedTypeDecl:
      return visitImplAssociatedTypeDeclSyntax(data)
    case .attributeList:
      return visitImplAttributeListSyntax(data)
    case .attribute:
      return visitImplAttributeSyntax(data)
    case .attributedType:
      return visitImplAttributedTypeSyntax(data)
    case .availabilityArgumentList:
      return visitImplAvailabilityArgumentListSyntax(data)
    case .availabilityArgument:
      return visitImplAvailabilityArgumentSyntax(data)
    case .availabilityCondition:
      return visitImplAvailabilityConditionSyntax(data)
    case .availabilityLabeledArgument:
      return visitImplAvailabilityLabeledArgumentSyntax(data)
    case .awaitExpr:
      return visitImplAwaitExprSyntax(data)
    case .backDeployedAttributeArguments:
      return visitImplBackDeployedAttributeArgumentsSyntax(data)
    case .binaryOperatorExpr:
      return visitImplBinaryOperatorExprSyntax(data)
    case .booleanLiteralExpr:
      return visitImplBooleanLiteralExprSyntax(data)
    case .borrowExpr:
      return visitImplBorrowExprSyntax(data)
    case .breakStmt:
      return visitImplBreakStmtSyntax(data)
    case .canImportExpr:
      return visitImplCanImportExprSyntax(data)
    case .canImportVersionInfo:
      return visitImplCanImportVersionInfoSyntax(data)
    case .catchClauseList:
      return visitImplCatchClauseListSyntax(data)
    case .catchClause:
      return visitImplCatchClauseSyntax(data)
    case .catchItemList:
      return visitImplCatchItemListSyntax(data)
    case .catchItem:
      return visitImplCatchItemSyntax(data)
    case .classDecl:
      return visitImplClassDeclSyntax(data)
    case .classRestrictionType:
      return visitImplClassRestrictionTypeSyntax(data)
    case .closureCaptureClause:
      return visitImplClosureCaptureClauseSyntax(data)
    case .closureCaptureList:
      return visitImplClosureCaptureListSyntax(data)
    case .closureCaptureSpecifier:
      return visitImplClosureCaptureSpecifierSyntax(data)
    case .closureCapture:
      return visitImplClosureCaptureSyntax(data)
    case .closureExpr:
      return visitImplClosureExprSyntax(data)
    case .closureParameterClause:
      return visitImplClosureParameterClauseSyntax(data)
    case .closureParameterList:
      return visitImplClosureParameterListSyntax(data)
    case .closureParameter:
      return visitImplClosureParameterSyntax(data)
    case .closureShorthandParameterList:
      return visitImplClosureShorthandParameterListSyntax(data)
    case .closureShorthandParameter:
      return visitImplClosureShorthandParameterSyntax(data)
    case .closureSignature:
      return visitImplClosureSignatureSyntax(data)
    case .codeBlockItemList:
      return visitImplCodeBlockItemListSyntax(data)
    case .codeBlockItem:
      return visitImplCodeBlockItemSyntax(data)
    case .codeBlock:
      return visitImplCodeBlockSyntax(data)
    case .compositionTypeElementList:
      return visitImplCompositionTypeElementListSyntax(data)
    case .compositionTypeElement:
      return visitImplCompositionTypeElementSyntax(data)
    case .compositionType:
      return visitImplCompositionTypeSyntax(data)
    case .conditionElementList:
      return visitImplConditionElementListSyntax(data)
    case .conditionElement:
      return visitImplConditionElementSyntax(data)
    case .conformanceRequirement:
      return visitImplConformanceRequirementSyntax(data)
    case .consumeExpr:
      return visitImplConsumeExprSyntax(data)
    case .continueStmt:
      return visitImplContinueStmtSyntax(data)
    case .conventionAttributeArguments:
      return visitImplConventionAttributeArgumentsSyntax(data)
    case .conventionWitnessMethodAttributeArguments:
      return visitImplConventionWitnessMethodAttributeArgumentsSyntax(data)
    case .copyExpr:
      return visitImplCopyExprSyntax(data)
    case .declModifierDetail:
      return visitImplDeclModifierDetailSyntax(data)
    case .declModifierList:
      return visitImplDeclModifierListSyntax(data)
    case .declModifier:
      return visitImplDeclModifierSyntax(data)
    case .declNameArgumentList:
      return visitImplDeclNameArgumentListSyntax(data)
    case .declNameArgument:
      return visitImplDeclNameArgumentSyntax(data)
    case .declNameArguments:
      return visitImplDeclNameArgumentsSyntax(data)
    case .declReferenceExpr:
      return visitImplDeclReferenceExprSyntax(data)
    case .deferStmt:
      return visitImplDeferStmtSyntax(data)
    case .deinitializerDecl:
      return visitImplDeinitializerDeclSyntax(data)
    case .deinitializerEffectSpecifiers:
      return visitImplDeinitializerEffectSpecifiersSyntax(data)
    case .derivativeAttributeArguments:
      return visitImplDerivativeAttributeArgumentsSyntax(data)
    case .designatedTypeList:
      return visitImplDesignatedTypeListSyntax(data)
    case .designatedType:
      return visitImplDesignatedTypeSyntax(data)
    case .dictionaryElementList:
      return visitImplDictionaryElementListSyntax(data)
    case .dictionaryElement:
      return visitImplDictionaryElementSyntax(data)
    case .dictionaryExpr:
      return visitImplDictionaryExprSyntax(data)
    case .dictionaryType:
      return visitImplDictionaryTypeSyntax(data)
    case .differentiabilityArgumentList:
      return visitImplDifferentiabilityArgumentListSyntax(data)
    case .differentiabilityArgument:
      return visitImplDifferentiabilityArgumentSyntax(data)
    case .differentiabilityArguments:
      return visitImplDifferentiabilityArgumentsSyntax(data)
    case .differentiabilityWithRespectToArgument:
      return visitImplDifferentiabilityWithRespectToArgumentSyntax(data)
    case .differentiableAttributeArguments:
      return visitImplDifferentiableAttributeArgumentsSyntax(data)
    case .discardAssignmentExpr:
      return visitImplDiscardAssignmentExprSyntax(data)
    case .discardStmt:
      return visitImplDiscardStmtSyntax(data)
    case .doStmt:
      return visitImplDoStmtSyntax(data)
    case .documentationAttributeArgumentList:
      return visitImplDocumentationAttributeArgumentListSyntax(data)
    case .documentationAttributeArgument:
      return visitImplDocumentationAttributeArgumentSyntax(data)
    case .dynamicReplacementAttributeArguments:
      return visitImplDynamicReplacementAttributeArgumentsSyntax(data)
    case .editorPlaceholderDecl:
      return visitImplEditorPlaceholderDeclSyntax(data)
    case .editorPlaceholderExpr:
      return visitImplEditorPlaceholderExprSyntax(data)
    case .effectsAttributeArgumentList:
      return visitImplEffectsAttributeArgumentListSyntax(data)
    case .enumCaseDecl:
      return visitImplEnumCaseDeclSyntax(data)
    case .enumCaseElementList:
      return visitImplEnumCaseElementListSyntax(data)
    case .enumCaseElement:
      return visitImplEnumCaseElementSyntax(data)
    case .enumCaseParameterClause:
      return visitImplEnumCaseParameterClauseSyntax(data)
    case .enumCaseParameterList:
      return visitImplEnumCaseParameterListSyntax(data)
    case .enumCaseParameter:
      return visitImplEnumCaseParameterSyntax(data)
    case .enumDecl:
      return visitImplEnumDeclSyntax(data)
    case .exposeAttributeArguments:
      return visitImplExposeAttributeArgumentsSyntax(data)
    case .exprList:
      return visitImplExprListSyntax(data)
    case .expressionPattern:
      return visitImplExpressionPatternSyntax(data)
    case .expressionSegment:
      return visitImplExpressionSegmentSyntax(data)
    case .expressionStmt:
      return visitImplExpressionStmtSyntax(data)
    case .extensionDecl:
      return visitImplExtensionDeclSyntax(data)
    case .fallThroughStmt:
      return visitImplFallThroughStmtSyntax(data)
    case .floatLiteralExpr:
      return visitImplFloatLiteralExprSyntax(data)
    case .forStmt:
      return visitImplForStmtSyntax(data)
    case .forceUnwrapExpr:
      return visitImplForceUnwrapExprSyntax(data)
    case .functionCallExpr:
      return visitImplFunctionCallExprSyntax(data)
    case .functionDecl:
      return visitImplFunctionDeclSyntax(data)
    case .functionEffectSpecifiers:
      return visitImplFunctionEffectSpecifiersSyntax(data)
    case .functionParameterClause:
      return visitImplFunctionParameterClauseSyntax(data)
    case .functionParameterList:
      return visitImplFunctionParameterListSyntax(data)
    case .functionParameter:
      return visitImplFunctionParameterSyntax(data)
    case .functionSignature:
      return visitImplFunctionSignatureSyntax(data)
    case .functionType:
      return visitImplFunctionTypeSyntax(data)
    case .genericArgumentClause:
      return visitImplGenericArgumentClauseSyntax(data)
    case .genericArgumentList:
      return visitImplGenericArgumentListSyntax(data)
    case .genericArgument:
      return visitImplGenericArgumentSyntax(data)
    case .genericParameterClause:
      return visitImplGenericParameterClauseSyntax(data)
    case .genericParameterList:
      return visitImplGenericParameterListSyntax(data)
    case .genericParameter:
      return visitImplGenericParameterSyntax(data)
    case .genericRequirementList:
      return visitImplGenericRequirementListSyntax(data)
    case .genericRequirement:
      return visitImplGenericRequirementSyntax(data)
    case .genericSpecializationExpr:
      return visitImplGenericSpecializationExprSyntax(data)
    case .genericWhereClause:
      return visitImplGenericWhereClauseSyntax(data)
    case .guardStmt:
      return visitImplGuardStmtSyntax(data)
    case .identifierPattern:
      return visitImplIdentifierPatternSyntax(data)
    case .identifierType:
      return visitImplIdentifierTypeSyntax(data)
    case .ifConfigClauseList:
      return visitImplIfConfigClauseListSyntax(data)
    case .ifConfigClause:
      return visitImplIfConfigClauseSyntax(data)
    case .ifConfigDecl:
      return visitImplIfConfigDeclSyntax(data)
    case .ifExpr:
      return visitImplIfExprSyntax(data)
    case .implementsAttributeArguments:
      return visitImplImplementsAttributeArgumentsSyntax(data)
    case .implicitlyUnwrappedOptionalType:
      return visitImplImplicitlyUnwrappedOptionalTypeSyntax(data)
    case .importDecl:
      return visitImplImportDeclSyntax(data)
    case .importPathComponentList:
      return visitImplImportPathComponentListSyntax(data)
    case .importPathComponent:
      return visitImplImportPathComponentSyntax(data)
    case .inOutExpr:
      return visitImplInOutExprSyntax(data)
    case .infixOperatorExpr:
      return visitImplInfixOperatorExprSyntax(data)
    case .inheritanceClause:
      return visitImplInheritanceClauseSyntax(data)
    case .inheritedTypeList:
      return visitImplInheritedTypeListSyntax(data)
    case .inheritedType:
      return visitImplInheritedTypeSyntax(data)
    case .initializerClause:
      return visitImplInitializerClauseSyntax(data)
    case .initializerDecl:
      return visitImplInitializerDeclSyntax(data)
    case .integerLiteralExpr:
      return visitImplIntegerLiteralExprSyntax(data)
    case .isExpr:
      return visitImplIsExprSyntax(data)
    case .isTypePattern:
      return visitImplIsTypePatternSyntax(data)
    case .keyPathComponentList:
      return visitImplKeyPathComponentListSyntax(data)
    case .keyPathComponent:
      return visitImplKeyPathComponentSyntax(data)
    case .keyPathExpr:
      return visitImplKeyPathExprSyntax(data)
    case .keyPathOptionalComponent:
      return visitImplKeyPathOptionalComponentSyntax(data)
    case .keyPathPropertyComponent:
      return visitImplKeyPathPropertyComponentSyntax(data)
    case .keyPathSubscriptComponent:
      return visitImplKeyPathSubscriptComponentSyntax(data)
    case .labeledExprList:
      return visitImplLabeledExprListSyntax(data)
    case .labeledExpr:
      return visitImplLabeledExprSyntax(data)
    case .labeledSpecializeArgument:
      return visitImplLabeledSpecializeArgumentSyntax(data)
    case .labeledStmt:
      return visitImplLabeledStmtSyntax(data)
    case .layoutRequirement:
      return visitImplLayoutRequirementSyntax(data)
    case .macroDecl:
      return visitImplMacroDeclSyntax(data)
    case .macroExpansionDecl:
      return visitImplMacroExpansionDeclSyntax(data)
    case .macroExpansionExpr:
      return visitImplMacroExpansionExprSyntax(data)
    case .matchingPatternCondition:
      return visitImplMatchingPatternConditionSyntax(data)
    case .memberAccessExpr:
      return visitImplMemberAccessExprSyntax(data)
    case .memberBlockItemList:
      return visitImplMemberBlockItemListSyntax(data)
    case .memberBlockItem:
      return visitImplMemberBlockItemSyntax(data)
    case .memberBlock:
      return visitImplMemberBlockSyntax(data)
    case .memberType:
      return visitImplMemberTypeSyntax(data)
    case .metatypeType:
      return visitImplMetatypeTypeSyntax(data)
    case .missingDecl:
      return visitImplMissingDeclSyntax(data)
    case .missingExpr:
      return visitImplMissingExprSyntax(data)
    case .missingPattern:
      return visitImplMissingPatternSyntax(data)
    case .missingStmt:
      return visitImplMissingStmtSyntax(data)
    case .missing:
      return visitImplMissingSyntax(data)
    case .missingType:
      return visitImplMissingTypeSyntax(data)
    case .multipleTrailingClosureElementList:
      return visitImplMultipleTrailingClosureElementListSyntax(data)
    case .multipleTrailingClosureElement:
      return visitImplMultipleTrailingClosureElementSyntax(data)
    case .namedOpaqueReturnType:
      return visitImplNamedOpaqueReturnTypeSyntax(data)
    case .nilLiteralExpr:
      return visitImplNilLiteralExprSyntax(data)
    case .objCSelectorPieceList:
      return visitImplObjCSelectorPieceListSyntax(data)
    case .objCSelectorPiece:
      return visitImplObjCSelectorPieceSyntax(data)
    case .opaqueReturnTypeOfAttributeArguments:
      return visitImplOpaqueReturnTypeOfAttributeArgumentsSyntax(data)
    case .operatorDecl:
      return visitImplOperatorDeclSyntax(data)
    case .operatorPrecedenceAndTypes:
      return visitImplOperatorPrecedenceAndTypesSyntax(data)
    case .optionalBindingCondition:
      return visitImplOptionalBindingConditionSyntax(data)
    case .optionalChainingExpr:
      return visitImplOptionalChainingExprSyntax(data)
    case .optionalType:
      return visitImplOptionalTypeSyntax(data)
    case .originallyDefinedInAttributeArguments:
      return visitImplOriginallyDefinedInAttributeArgumentsSyntax(data)
    case .packElementExpr:
      return visitImplPackElementExprSyntax(data)
    case .packElementType:
      return visitImplPackElementTypeSyntax(data)
    case .packExpansionExpr:
      return visitImplPackExpansionExprSyntax(data)
    case .packExpansionType:
      return visitImplPackExpansionTypeSyntax(data)
    case .patternBindingList:
      return visitImplPatternBindingListSyntax(data)
    case .patternBinding:
      return visitImplPatternBindingSyntax(data)
    case .patternExpr:
      return visitImplPatternExprSyntax(data)
    case .platformVersionItemList:
      return visitImplPlatformVersionItemListSyntax(data)
    case .platformVersionItem:
      return visitImplPlatformVersionItemSyntax(data)
    case .platformVersion:
      return visitImplPlatformVersionSyntax(data)
    case .postfixIfConfigExpr:
      return visitImplPostfixIfConfigExprSyntax(data)
    case .postfixOperatorExpr:
      return visitImplPostfixOperatorExprSyntax(data)
    case .poundSourceLocationArguments:
      return visitImplPoundSourceLocationArgumentsSyntax(data)
    case .poundSourceLocation:
      return visitImplPoundSourceLocationSyntax(data)
    case .precedenceGroupAssignment:
      return visitImplPrecedenceGroupAssignmentSyntax(data)
    case .precedenceGroupAssociativity:
      return visitImplPrecedenceGroupAssociativitySyntax(data)
    case .precedenceGroupAttributeList:
      return visitImplPrecedenceGroupAttributeListSyntax(data)
    case .precedenceGroupDecl:
      return visitImplPrecedenceGroupDeclSyntax(data)
    case .precedenceGroupNameList:
      return visitImplPrecedenceGroupNameListSyntax(data)
    case .precedenceGroupName:
      return visitImplPrecedenceGroupNameSyntax(data)
    case .precedenceGroupRelation:
      return visitImplPrecedenceGroupRelationSyntax(data)
    case .prefixOperatorExpr:
      return visitImplPrefixOperatorExprSyntax(data)
    case .primaryAssociatedTypeClause:
      return visitImplPrimaryAssociatedTypeClauseSyntax(data)
    case .primaryAssociatedTypeList:
      return visitImplPrimaryAssociatedTypeListSyntax(data)
    case .primaryAssociatedType:
      return visitImplPrimaryAssociatedTypeSyntax(data)
    case .protocolDecl:
      return visitImplProtocolDeclSyntax(data)
    case .regexLiteralExpr:
      return visitImplRegexLiteralExprSyntax(data)
    case .repeatStmt:
      return visitImplRepeatStmtSyntax(data)
    case .returnClause:
      return visitImplReturnClauseSyntax(data)
    case .returnStmt:
      return visitImplReturnStmtSyntax(data)
    case .sameTypeRequirement:
      return visitImplSameTypeRequirementSyntax(data)
    case .sequenceExpr:
      return visitImplSequenceExprSyntax(data)
    case .simpleStringLiteralExpr:
      return visitImplSimpleStringLiteralExprSyntax(data)
    case .simpleStringLiteralSegmentList:
      return visitImplSimpleStringLiteralSegmentListSyntax(data)
    case .someOrAnyType:
      return visitImplSomeOrAnyTypeSyntax(data)
    case .sourceFile:
      return visitImplSourceFileSyntax(data)
    case .specializeAttributeArgumentList:
      return visitImplSpecializeAttributeArgumentListSyntax(data)
    case .specializeAvailabilityArgument:
      return visitImplSpecializeAvailabilityArgumentSyntax(data)
    case .specializeTargetFunctionArgument:
      return visitImplSpecializeTargetFunctionArgumentSyntax(data)
    case .stringLiteralExpr:
      return visitImplStringLiteralExprSyntax(data)
    case .stringLiteralSegmentList:
      return visitImplStringLiteralSegmentListSyntax(data)
    case .stringSegment:
      return visitImplStringSegmentSyntax(data)
    case .structDecl:
      return visitImplStructDeclSyntax(data)
    case .subscriptCallExpr:
      return visitImplSubscriptCallExprSyntax(data)
    case .subscriptDecl:
      return visitImplSubscriptDeclSyntax(data)
    case .superExpr:
      return visitImplSuperExprSyntax(data)
    case .suppressedType:
      return visitImplSuppressedTypeSyntax(data)
    case .switchCaseItemList:
      return visitImplSwitchCaseItemListSyntax(data)
    case .switchCaseItem:
      return visitImplSwitchCaseItemSyntax(data)
    case .switchCaseLabel:
      return visitImplSwitchCaseLabelSyntax(data)
    case .switchCaseList:
      return visitImplSwitchCaseListSyntax(data)
    case .switchCase:
      return visitImplSwitchCaseSyntax(data)
    case .switchDefaultLabel:
      return visitImplSwitchDefaultLabelSyntax(data)
    case .switchExpr:
      return visitImplSwitchExprSyntax(data)
    case .ternaryExpr:
      return visitImplTernaryExprSyntax(data)
    case .throwStmt:
      return visitImplThrowStmtSyntax(data)
    case .tryExpr:
      return visitImplTryExprSyntax(data)
    case .tupleExpr:
      return visitImplTupleExprSyntax(data)
    case .tuplePatternElementList:
      return visitImplTuplePatternElementListSyntax(data)
    case .tuplePatternElement:
      return visitImplTuplePatternElementSyntax(data)
    case .tuplePattern:
      return visitImplTuplePatternSyntax(data)
    case .tupleTypeElementList:
      return visitImplTupleTypeElementListSyntax(data)
    case .tupleTypeElement:
      return visitImplTupleTypeElementSyntax(data)
    case .tupleType:
      return visitImplTupleTypeSyntax(data)
    case .typeAliasDecl:
      return visitImplTypeAliasDeclSyntax(data)
    case .typeAnnotation:
      return visitImplTypeAnnotationSyntax(data)
    case .typeEffectSpecifiers:
      return visitImplTypeEffectSpecifiersSyntax(data)
    case .typeExpr:
      return visitImplTypeExprSyntax(data)
    case .typeInitializerClause:
      return visitImplTypeInitializerClauseSyntax(data)
    case .unavailableFromAsyncAttributeArguments:
      return visitImplUnavailableFromAsyncAttributeArgumentsSyntax(data)
    case .underscorePrivateAttributeArguments:
      return visitImplUnderscorePrivateAttributeArgumentsSyntax(data)
    case .unexpectedNodes:
      return visitImplUnexpectedNodesSyntax(data)
    case .unresolvedAsExpr:
      return visitImplUnresolvedAsExprSyntax(data)
    case .unresolvedIsExpr:
      return visitImplUnresolvedIsExprSyntax(data)
    case .unresolvedTernaryExpr:
      return visitImplUnresolvedTernaryExprSyntax(data)
    case .valueBindingPattern:
      return visitImplValueBindingPatternSyntax(data)
    case .variableDecl:
      return visitImplVariableDeclSyntax(data)
    case .versionComponentList:
      return visitImplVersionComponentListSyntax(data)
    case .versionComponent:
      return visitImplVersionComponentSyntax(data)
    case .versionTuple:
      return visitImplVersionTupleSyntax(data)
    case .whereClause:
      return visitImplWhereClauseSyntax(data)
    case .whileStmt:
      return visitImplWhileStmtSyntax(data)
    case .wildcardPattern:
      return visitImplWildcardPatternSyntax(data)
    case .yieldStmt:
      return visitImplYieldStmtSyntax(data)
    case .yieldedExpressionList:
      return visitImplYieldedExpressionListSyntax(data)
    case .yieldedExpression:
      return visitImplYieldedExpressionSyntax(data)
    case .yieldedExpressionsClause:
      return visitImplYieldedExpressionsClauseSyntax(data)
    }
  }
  #endif
  
  private func visitChildren<SyntaxType: SyntaxProtocol>(
    _ node: SyntaxType
  ) -> SyntaxType {
    // Walk over all children of this node and rewrite them. Don't store any
    // rewritten nodes until the first non-`nil` value is encountered. When this
    // happens, retrieve all previous syntax nodes from the parent node to
    // initialize the new layout. Once we know that we have to rewrite the
    // layout, we need to collect all further children, regardless of whether
    // they are rewritten or not.

    // newLayout is nil until the first child node is rewritten and rewritten
    // nodes are being collected.
    var newLayout: ContiguousArray<RawSyntax?>?

    // Rewritten children just to keep their 'SyntaxArena' alive until they are
    // wrapped with 'Syntax'
    var rewrittens: ContiguousArray<Syntax> = []

    let syntaxNode = node._syntaxNode

    // Incrementing i manually is faster than using .enumerated()
    var childIndex = 0
    for (raw, info) in RawSyntaxChildren(syntaxNode) {
      defer {
        childIndex += 1
      }

      guard let child = raw, viewMode.shouldTraverse(node: child) else {
        // Node does not exist or should not be visited. If we are collecting
        // rewritten nodes, we need to collect this one as well, otherwise we
        // can ignore it.
        if newLayout != nil {
          newLayout!.append(raw)
        }
        continue
      }

      // Build the Syntax node to rewrite
      let absoluteRaw = AbsoluteRawSyntax(raw: child, info: info)
      let data = SyntaxData(absoluteRaw, parent: syntaxNode)

      let rewritten = visit(data)
      if rewritten.data.nodeId != info.nodeId {
        // The node was rewritten, let's handle it
        if newLayout == nil {
          // We have not yet collected any previous rewritten nodes. Initialize
          // the new layout with the previous nodes of the parent. This is
          // possible, since we know they were not rewritten.

          // The below implementation is based on Collection.map but directly
          // reserves enough capacity for the entire layout.
          newLayout = ContiguousArray<RawSyntax?>()
          newLayout!.reserveCapacity(node.raw.layoutView!.children.count)
          for j in 0 ..< childIndex {
            newLayout!.append(node.raw.layoutView!.children[j])
          }
        }

        // Now that we know we have a new layout in which we collect rewritten
        // nodes, add it.
        rewrittens.append(rewritten)
        newLayout!.append(rewritten.raw)
      } else {
        // The node was not changed by the rewriter. Only store it if a previous
        // node has been rewritten and we are collecting a rewritten layout.
        if newLayout != nil {
          newLayout!.append(raw)
        }
      }
    }

    if let newLayout {
      // A child node was rewritten. Build the updated node.

      // Sanity check, ensure the new children are the same length.
      precondition(newLayout.count == node.raw.layoutView!.children.count)

      let arena = SyntaxArena()
      let newRaw = node.raw.layoutView!.replacingLayout(with: Array(newLayout), arena: arena)
      // 'withExtendedLifetime' to keep 'SyntaxArena's of them alive until here.
      return withExtendedLifetime(rewrittens) {
        Syntax(raw: newRaw, rawNodeArena: arena).cast(SyntaxType.self)
      }
    } else {
      // No child node was rewritten. So no need to change this node as well.
      return node
    }
  }
}
